#Include-Once

Func guiChoixProfil()
	Local $GUI = GUICreate($nAiO_title&" v"&$nAiO_version&" : "&getInternationalisationText($nAiO_languageResources, "CP_title"), 200, 85, Default, Default, $WS_POPUP+$WS_BORDER )

	Local $GUI_PROFIL_L = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "CP_label"), 10,  8,  100, 20), $GUI_PROFIL = GUICtrlCreateCombo("",   105,  5,  85, 20)
	Local $GUI_PASSWORD = GUICtrlCreateInput("",   10, 30, 180, 20, 160) ; $ES_PASSWORD = 32  /  $ES_AUTOHSCROLL = 128
	Local $GUI_VALIDER  = GUICtrlCreateButton("", 10, 55,  85, 25), $GUI_QUITTER = GUICtrlCreateButton("", 105, 55,  85, 25)

	GUICtrlSetTip($GUI_PROFIL,  getInternationalisationText($nAiO_languageResources, "CP_tip_profil"))
	GUICtrlSetTip($GUI_QUITTER,  getInternationalisationText($nAiO_languageResources, "CP_tip_quitter"))
	GUICtrlSetTip($GUI_PASSWORD, getInternationalisationText($nAiO_languageResources, "CP_tip_password"))
	GUICtrlSetTip($GUI_VALIDER,  getInternationalisationText($nAiO_languageResources, "CP_tip_valider"))

	GUICtrlSetFont($GUI_QUITTER,  18, 400, 0, "Wingdings")
	GUICtrlSetFont($GUI_VALIDER,  18, 400, 0, "Wingdings")

	Local $MENU_PROFIL = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $comboData = "", $comboDataDefault = ""
	If getListeProfilsLength($nAiO_listeProfils) = 0 Then
		SetError(1)
		Return False
	Else
;~ 		If getListeProfilsLength($nAiO_listeProfils) = 1 Then GUICtrlSetState($GUI_PROFIL, $GUI_DISABLE)
		; Pour chaque profil, cre un menu de 'Profil'
		Local $comboData = "", $comboDataDefault = ""
		For $i = 1 To getListeProfilsLength($nAiO_listeProfils)
			Local $profil = getProfilInListAt($nAiO_listeProfils,$i)
			$comboData &= "|"&getProfilNom($profil)
			If getProfilNom($profil) = getProfilNom(getProfilActuel()) Then
				GUICtrlSetState($GUI_PASSWORD,    cond(isProfilProtected($profil),$GUI_ENABLE,$GUI_DISABLE))
				$comboDataDefault = getProfilNom($profil)
			EndIf
		Next
		GUICtrlSetData($GUI_PROFIL,$comboData,$comboDataDefault)
	EndIf

	If $comboDataDefault = "" Then
		SetError(2)
		Return False
	EndIf

;~ 	GUICtrlSetState($GUI_PROFIL_L,$GUI_DISABLE)
	GUICtrlSetState($GUI_PASSWORD,$GUI_FOCUS)
	GUISetState(@SW_SHOW, $GUI)

	Local $dll = DllOpen("user32.dll"), $ok = False, $loop = True, $previous_profilValue = GUICtrlRead($GUI_PROFIL)
	Do
		Local $msg = GUIGetMsg()
		Switch $msg
		Case $GUI_VALIDER, $GUI_QUITTER
			$ok = ($msg = $GUI_VALIDER)
			$loop = False
		Case $GUI_PROFIL
			sousmenu($GUI, $GUI_PROFIL, $MENU_PROFIL)
		Case Else
			If WinActive($GUI) And _IsPressed("0D",$dll) Then
				$ok = True
				$loop = False
			ElseIf WinActive($GUI) And _IsPressed("1B",$dll) Then
				$loop = False
			ElseIf $previous_profilValue <> GUICtrlRead($GUI_PROFIL) Then
				$previous_profilValue = GUICtrlRead($GUI_PROFIL)
				GUICtrlSetData($GUI_PASSWORD,  "")
				GUICtrlSetState($GUI_PASSWORD, $GUI_DISABLE)
				GUICtrlSetState($GUI_VALIDER,  $GUI_DISABLE)
				For $i = 1 To getListeProfilsLength($nAiO_listeProfils)
					Local $profil = getProfilInListAt($nAiO_listeProfils,$i)
					If $previous_profilValue = getProfilNom($profil) Then
						GUICtrlSetState($GUI_PASSWORD, cond(isProfilProtected($profil),$GUI_ENABLE,$GUI_DISABLE))
						GUICtrlSetState($GUI_VALIDER,  $GUI_ENABLE)
					EndIf
				Next
			EndIf
		EndSwitch
	Until Not $loop
	DllClose($dll)
	Local $profil = GUICtrlRead($GUI_PROFIL)
	Local $pass   = GUICtrlRead($GUI_PASSWORD)
	GUIDelete($GUI)
	Sleep(1000)
	If $ok Then
		$profil = getProfilInListFromNom($nAiO_listeProfils,$profil)
		If isProfil($profil) And Not isProfilProtected($profil) Or checkProfilPassword($pass, $profil) Then
			setProfilActuel($profil)
			$nAiO_profil_password = $pass
			Return True
		EndIf
		; Message d'erreur
		If Not isProfil($profil) Then
			MsgBox(16,$nAiO_title&" v"&$nAiO_version&" : "&getInternationalisationText($nAiO_languageResources, "CP_title"), _
				getInternationalisationText($nAiO_languageResources, "CP_msg_profilinconnu"), 15 _
			)
		Else
			MsgBox(16,$nAiO_title&" v"&$nAiO_version&" : "&getInternationalisationText($nAiO_languageResources, "CP_title"), _
				getInternationalisationText($nAiO_languageResources, "CP_msg_passwordincorrect"), 15 _
			)
		EndIf
	EndIf
	Return False
EndFunc
