#Region Fonctions de contrle de la souris
Func RelativeMouseClick($button, $x, $y, $clicks = 1, $speed = 10)
	Local $resultat, $opt = Opt("MouseCoordMode")
	Opt("MouseCoordMode",2)
	$resultat = MouseClick($button, $x, $y, $clicks, $speed)
	Opt("MouseCoordMode",$opt)
	Return $resultat
EndFunc
Func RelativeMouseMove($x, $y, $speed = 10)
	Local $resultat, $opt = Opt("MouseCoordMode")
	Opt("MouseCoordMode",2)
	$resultat = MouseMove($x, $y, $speed)
	Opt("MouseCoordMode",$opt)
	Return $resultat
EndFunc
Func RelativeMouseGetPos($dimension = -1)
	Local $resultat, $error = False, $opt = Opt("MouseCoordMode")
	Opt("MouseCoordMode",2)
	If $dimension = -1 Then
		$resultat = MouseGetPos()
	ElseIf $dimension = 0 Or $dimension = 1 Then
		$resultat = MouseGetPos($dimension)
	Else
		$error = True
	EndIf
	$error = $error Or @error <> 0
	Opt("MouseCoordMode",$opt)
	If Not $error Then Return $resultat
	SetError(1)
EndFunc
Func RelativePixelGetColor($x, $y)
	Local $resultat, $opt = Opt("PixelCoordMode")
	Opt("PixelCoordMode",2)
	$resultat = PixelGetColor($x, $y)
	Opt("PixelCoordMode",$opt)
	Return $resultat
EndFunc
Func RelativePixelGetColorHwnd($x, $y, $hwnd)
	Local $resultat, $opt = Opt("PixelCoordMode")
	Opt("PixelCoordMode",2)
	$resultat = PixelGetColor($x, $y, $hwnd)
	Opt("PixelCoordMode",$opt)
	Return $resultat
EndFunc
#EndRegion