#Include-Once

#Include <Crypt.au3>

#Region Encryptage/dcryptage des donnes
Global Const $DEFAULT_Key      = ""
Global Const $DEFAULT_Password = ""
Global Const $SALT_Value       = ""

Func autoencryptage($data)
	Local $longueur = 256, $valeur = previous_encryptage($SALT_Value&$data,$SALT_Value&$data)
	If StringLen($valeur) = 0 Then Return ""
	While StringLen($valeur) < $longueur
		$valeur = $valeur&$valeur
	WEnd
	$valeur = StringLeft($valeur,$longueur)
	$valeur = String(_Crypt_HashData($SALT_Value&$valeur,$CALG_MD5))
	Return $valeur
EndFunc

Func encryptage($data, $clef)
	Return String(_Crypt_EncryptData(Random(1000,9999,1)&$SALT_Value&$data, $clef, $CALG_AES_256))
EndFunc

Func previous_encryptage($data, $clef)
	Return String(_Crypt_EncryptData($SALT_Value&$data, $clef, $CALG_AES_256))
EndFunc

Func decryptage($data, $clef)
	Local $valeur = String(BinaryToString(_Crypt_DecryptData($data, $clef, $CALG_AES_256)))
	Local $salt = StringRight(StringLeft($valeur,5),1), $int = Number(StringLeft($valeur,4))
	If $salt = $SALT_Value And 1000 <= $int And $int <= 9999 Then Return StringTrimLeft($valeur,5)
	Return previous_decryptage($data, $clef)
EndFunc

Func previous_decryptage($data, $clef)
	Local $valeur = String(BinaryToString(_Crypt_DecryptData($data, $clef, $CALG_AES_256)))
	If StringLeft($valeur,1) = $SALT_Value Then Return StringTrimLeft($valeur,1)
	Return ""
EndFunc
