#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Mininit\Mininit.ico
#AutoIt3Wrapper_outfile=Mininit.exe
#AutoIt3Wrapper_Res_FileVersion=1.5.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|Mininit
#AutoIt3Wrapper_Res_Field=Nom (long)|Mininit
#AutoIt3Wrapper_Res_Field=Version (short)|1.5a
#AutoIt3Wrapper_Res_Field=Version (long)|1.5.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de gestion de fentres
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|Za [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#comments-start
- Inclure les icnes des fentres
- Ajouter un bouton pour donner une valeur/NaN/vide  la priorit ? <-  faire pour la 1.5
- Voir si besoin de baisser la fentre quand passage de l'une  l'autre <-  faire pour la 1.5
- Rajouter la ligne {Cette fentre} dsignant la fentre en cours, pour la baisser rapidement <-  faire pour la 1.5.0.0
- Permettre la mise sur le devant d'une fentre qui clignotte ? <- en cours,  finir pour la 1.5.0.0
- Gestion des crans avec _WinAPI_EnumDisplayDevices() de <WinAPI.au3> <-  tudier avec la rorganisation des fentres.
- Mettre en place le skin du DamageCalc !! <- non-prioritaire,  faire avec ci-dessous
- Refondre les interfaces pour utiliser des arrays de GUICtrl, pour simplifier le traitement des objets (et claircir l'array principal si possible)
#comments-end

#Region Options AutoIt
AutoItSetOption("MustDeclareVars", 1)
AutoItSetOption("GUIOnEventMode", 1)
AutoItSetOption("TrayAutoPause", 0)
AutoItSetOption("TrayMenuMode", 1)
AutoItSetOption("TrayOnEventMode", 1)
AutoItSetOption("GUIResizeMode", 544) ;$GUI_DOCKTOP+$GUI_DOCKHEIGHT
#EndRegion

#Region Librairies AutoIt
#include <Array.au3> ;_ArraySort
;~ #include <WinAPI.au3> ;_WinAPI_EnumWindows + _WinAPI_EnumProcesses + _WinAPI_EnumDisplayDevices
#EndRegion

#Region Entte du module
Global Const _
	$MODULE_NOM = "Mininit", $MODULE_AUTEUR = "Za", $MODULE_VERSION = "1.5.0.1", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")
#EndRegion

; Compilation
#Include ".\Mininit\Compilation.au3"

#Region Main
Global $Ini, $Fenetre, $f_FenetreSecondaire, $s_Processus = "Dofus", $s_BlackListe = ";Msg;Dummy;MSCTFIME UI;Default IME", _
		$Auto = 1, $Dessus = 1, $Mini = 0, $Config = 0, $Debug = 0, $Shortcut = 1, $Init = 1, $pause = 0, _
		$RPBox = 0, $RPBoxFlashMode = 1, $RPBoxCensoreMode = 0, $RPBoxCheckboxCensure, $RPBoxInputCensure, $RPBoxComboPrefix, $RPBoxComboWin, $RPBoxEdit, $RPText = "", _
		$AutoWin = 0, $AutoSuiv = 0, $AutoPrec = 0, _
		$s_LangTexte = "FR", $s_LangChargeModule = "Chargement du module...", $s_LangChargeFenetre = "Mise en place de la fentre...", $s_LangSuivanteWin = "(Suivante)", $s_LangSuivanteProc = "Suivante", $s_LangPrecedenteWin = "(Prcdente)", $s_LangPrecedenteProc = "Prcdente", $s_LangConfigure = "Configuration", $s_LangTipConfigure = "Permet de choisir les processus  chercher, ainsi que les fentres  ignorer.", $s_LangAuto = "Auto", $s_LangDessus = "Dessus", $s_LangMini = "Mini", $s_LangExit = "Exit", $s_LangReorganisation = "Rorganisation", $s_LangRaccourcis = "Raccourcis", $s_LangTipRaccourcis = "Affiche les raccourcis du clavier associs aux fentres.", $s_LangInitiatives = "Initiatives", $s_LangTipInitiatives = "Montre les initiatives des fentres.", $s_LangRafraichir = "Rafrachir", $s_LangTipRafraichir = "Met  jour la fentre.", $s_LangEnregistrer = "Enregistrer", $s_LangTipEnregistrer = "Sauvegarde l'tat de la fentre.", $s_LangCharger = "Charger", $s_LangTipCharger = "Recharge l'tat de la fentre.", $s_LangTextePrincipal = "Choisissez la fentre  placer au premier plan :", $s_LangTipTextePrincipal = "Cliquez ici pour ouvrir la configuration.", $s_LangBoutonPrecedent = "<", $s_LangTipBoutonPrecedent = "Activer la fentre prcdente dans l'ordre de priorit.", $s_LangBoutonSuivant = ">", $s_LangTipBoutonSuivant = "Activer la fentre suivante dans l'ordre de priorit.", $s_LangMenuActiverFenetre = "Activer cette fentre", $s_LangMenuCopierFenetre = "Copier le nom dans le presse-papier", $s_LangTipActiverFenetre = "Cliquez ici pour activer la fentre", $s_LangAffecterRaccourci = "Dsigne la touche-raccourci pour activer la fentre", $s_LangControle = "Ctrl", $s_LangShift = "Shift", $s_LangAlternative = "Alt", $s_LangWindows = "Win", $s_LangTipCocherRaccourcis = "Cochez cette case pour utiliser", $s_LangTipCocherOption = "Cocher la case", $s_LangTipOptionDessus = "place la fentre du module sur le devant.", $s_LangTipOptionMini = "rend le module plus discret.", $s_LangTipOptionInitiatives = "Ordre de priorit de la fentre", $s_LangTipNaN = "Entrez NaN pour ignorer.", $s_LangTexteSecondaireDebut = "Veuillez ouvrir une fentre", $s_LangTexteSecondaireFin = ", svp.", $s_LangTipAuto = "Sauvegarde automatiquement les modifications (quand la case est coche).", $s_LangTipReorganisation = "Gestion de la rorganisation automatique des fentres.", $s_LangReorganiseFenetre = "Fentre", $s_LangTipReorganiseFenetre = "Automatiquement rorganiser en passant par la fentre.", $s_LangTipSuivanteProc = "Automatiquement rorganiser en passant  la Suivante.", $s_LangTipPrecedenteProc = "Automatiquement rorganiser en passant  la Prcdente.", $s_LangProcessus = "Processus :", $s_LangTipProcessus = "Ceci est la liste des processus disponibles, cliquez pour ajouter.", $s_LangTipListProcDebut = "Voici la recherche des processus qui sera faite, vous pouvez la modifier", $s_LangTipListProcFin = "en ajoutant des noms  la main, spars par "";"".", $s_LangProcessusAcceptes = "Accepts :", $s_LangTipProcessusAcceptes = "Ceci est la liste des processus qui seront recherchs, cliquez pour retirer.", $s_LangFenetres = "Fentres :", $s_LangTipFenetres = "Ceci est la liste des fentres associes au processus, cliquez pour black-lister.", $s_LangFenetresIgnorees = "Ignores :", $s_LangTipFenetresIgnorees = "Ceci est la liste des fentres black-listes, cliquez pour ds-ignorer.";,

Dim $a_WinProc[2][19], $a_Tray[4][1], $a_Controls[5]
Local $Incremental = 0, $Compteur = TimerInit(), $a_Timer, $a_ProcessGetWindows, $i
Dim $a_Timer[1][4], $a_ProcessGetWindows[1][4]

HotKeySet("{INS}", "SendClip")
HotKeySet("{ESC}", "pause")

$Ini = $MODULE_DIR & "\" & $MODULE_NOM & ".ini"
$Auto = IniRead($Ini, "Configuration", "Auto", $Auto)
ChargeLang($MODULE_DIR & "\Language\" & $s_LangTexte & ".lng", $s_LangTexte)
Main()
;~ $Incremental = $a_WinProc[0][3] ;initialisation n'importe-o, c'est sans importance
While 1
	Sleep(999)
	#cs ;--> Fonctions de gestion d'une fentre clignottante
		$Incremental = ProcSuiv($Incremental) ;handle de la fentre en cours de test, boucle sur la liste des fentres dtectes qui n'ont pas "NaN" en initiative
		;~ 	$a_ProcessGetWindows = isWindowFlashing($Incremental)
		;~ 	TrayTip($a_ProcessGetWindows, $Incremental, 0) ;information pour le droulement des tests
		If isWindowFlashing($Incremental) Then ;Elle a t dtecte "flashante" ! ;... Mais la fonction la fait flasher par dfaut, ce qui n'est pas le comportement dsir.
		;~ 		MsgBox(0, $Incremental, "ouaiiiis" & WinGetTitle($Incremental)) ;Bon, au-moins, c'est visible, quoi. :p
		For $i = 0 To UBound($a_WinProc) - 2 ;parcours de la liste pour retrouver la fentre associe au processus
		If $a_WinProc[$i][3] = $Incremental Then ;hop
		$a_WinProc[UBound($a_WinProc) - 2][14] = $i ;on fait comme si l'utilisateur l'avait choisie volontairement
		$a_WinProc[UBound($a_WinProc) - 1][14] = $i
		ExitLoop
		EndIf
		Next
		FenActive($Incremental) ;et elle est place sur le devant de la scne.
		EndIf
	#ce ;--> Fin de gestion des fentres clignottantes
WEnd
Exit
#EndRegion Main

#Region Functions
Func Main($Reload = 0) ;affichage de la fentre principale
	TrayTip(@ScriptName, $s_LangChargeModule, 0)
	Local $a_ProcessGetWindows, $a_PosF, $f_Temporaire, $a_Temporaire, $i, $j, $k, $l, $i_Ubound = UBound($a_WinProc, 2);
	Dim $a_ProcessGetWindows[1], $a_PosF[1], $a_Temporaire[2][$i_Ubound]
	If $Reload = 1 Then $Auto = IniRead($Ini, "Configuration", "Auto", $Auto)
	If $Auto = 1 Or $Reload = 1 Then
		$s_Processus = StringReplace(StringReplace(IniRead($Ini, "Configuration", "Processus", $s_Processus), " OU", ";"), "; ", ";")
		$s_BlackListe = StringReplace(IniRead($Ini, "Configuration", "BlackListe", $s_BlackListe), "|", ";")
		$Config = IniRead($Ini, "Configuration", "Config", $Config)
		$Dessus = IniRead($Ini, "Configuration", "Dessus", $Dessus)
		$Init = IniRead($Ini, "Configuration", "Init", $Init)
		$Mini = IniRead($Ini, "Configuration", "Mini", $Mini)
		$Shortcut = IniRead($Ini, "Configuration", "Shortcut", $Shortcut)
		$AutoWin = IniRead($Ini, "Configuration", "AutoWin", $AutoWin)
		$AutoSuiv = IniRead($Ini, "Configuration", "AutoSuiv", $AutoSuiv)
		$AutoPrec = IniRead($Ini, "Configuration", "AutoPrec", $AutoPrec)
		$RPBoxCensoreMode = IniRead($Ini, "RP_Box", "Censure", $RPBoxCensoreMode)
		$RPBoxFlashMode = IniRead($Ini, "RP_Box", "Flash", $RPBoxFlashMode)
	EndIf
	$a_ProcessGetWindows = ProcessGetWin(2 + 8, $s_Processus, $s_BlackListe)
	If UBound($a_ProcessGetWindows) > 1 Or $a_ProcessGetWindows[0][0] <> "" Then ;parcours de la liste du processus trouv
		ReDim $a_Temporaire[UBound($a_ProcessGetWindows) + 2][UBound($a_Temporaire, 2)]
		$a_Temporaire[UBound($a_Temporaire) - 2][2] = $s_LangSuivanteWin
		$a_Temporaire[UBound($a_Temporaire) - 2][0] = $s_LangSuivanteProc
		$a_Temporaire[UBound($a_Temporaire) - 1][2] = $s_LangPrecedenteWin
		$a_Temporaire[UBound($a_Temporaire) - 1][0] = $s_LangPrecedenteProc
		For $i = 0 To UBound($a_ProcessGetWindows) - 1
			For $j = 0 To UBound($a_ProcessGetWindows, 2) - 1
				$a_Temporaire[$i][$j] = $a_ProcessGetWindows[$i][$j]
			Next
			For $j = 0 To UBound($a_WinProc) - 1 ;recopie des informations si dj existantes
				If $a_Temporaire[$i][0] = $a_WinProc[$j][0] And $a_Temporaire[$i][3] = $a_WinProc[$j][3] Then
					For $k = 0 To UBound($a_Temporaire, 2) - 1
						$a_Temporaire[$i][$k] = $a_WinProc[$j][$k]
					Next
				EndIf
			Next
		Next
	EndIf
	$a_Temporaire[UBound($a_Temporaire) - 2][2] = $s_LangSuivanteWin
	$a_Temporaire[UBound($a_Temporaire) - 2][0] = $s_LangSuivanteProc
	$a_Temporaire[UBound($a_Temporaire) - 1][2] = $s_LangPrecedenteWin
	$a_Temporaire[UBound($a_Temporaire) - 1][0] = $s_LangPrecedenteProc
	$a_WinProc = $a_Temporaire
	If $Auto = 1 Or $Reload = 1 Then ;chargement des valeurs enregistres
		HotRead()
		InitRead()
	EndIf
	KeySet("HotKey") ;application des raccourcis sur les fentres
	If $Fenetre <> "" Then PosFenetre($Fenetre, $Auto, 1) ;sauvegarde de la position actuelle de la fentre
	$a_PosF = PosFenetre($Fenetre, BitOR($Reload, $Auto)) ;chargement de la position de la fentre
	$f_Temporaire = Fenetre(0, $a_PosF[0], $a_PosF[1], $a_PosF[2]) ;ouverture d'une nouvelle fentre
	If $Fenetre <> "" Then GUIDelete($Fenetre) ;fermeture de l'ancienne si existante
	$Fenetre = $f_Temporaire ;mise  jour de la variable

	;Ne serait-il pas plus intressant de mettre a dans la reconstruction de la fentre ?? // Si, mais ce sera mieux gr pour la prochaine fois, la fentre ne sera plus dtruite.
	For $i = 0 To UBound($a_Tray) - 1 ;dconstruction du traytool
		TrayItemDelete($a_Tray[$i][0])
	Next
	$i_Ubound = UBound($a_WinProc)
	Dim $a_Tray[2 + $i_Ubound + 7][UBound($a_Tray, 2)] ;reconstruction du traytool
	$a_Tray[0][0] = TrayCreateItem("nAiO - " & $MODULE_NOM & " - " & $MODULE_VERSION)
	TrayItemSetOnEvent($a_Tray[0][0], "Recharge")
	$a_Tray[1][0] = TrayCreateItem("")
	For $i = 0 To $i_Ubound - 1
		$l = $a_WinProc[$i][0]
		For $j = 0 To $i_Ubound - 1
			If $j <> $i And $a_WinProc[$j][0] = $a_WinProc[$i][0] Then
				$l = $a_WinProc[$i][2]
				ExitLoop
			EndIf
		Next
		If $l = "" Then $l = "NaN"
		$a_Tray[$i + 2][0] = TrayCreateItem(StringReplace($l, "&", "&&") & " :")
		TrayItemSetOnEvent($a_Tray[$i + 2][0], "HotTray")
	Next
	$i_Ubound = UBound($a_Tray)
	$a_Tray[$i_Ubound - 7][0] = TrayCreateItem("")
	$a_Tray[$i_Ubound - 6][0] = TrayCreateMenu($s_LangConfigure)
	$a_Tray[$i_Ubound - 5][0] = TrayCreateItem($s_LangAuto, $a_Tray[$i_Ubound - 6][0])
	TrayItemSetOnEvent($a_Tray[$i_Ubound - 5][0], "SetAuto")
	TrayItemSetState($a_Tray[$i_Ubound - 5][0], 4 - 3 * $Auto)
	$a_Tray[$i_Ubound - 4][0] = TrayCreateItem($s_LangDessus, $a_Tray[$i_Ubound - 6][0])
	TrayItemSetOnEvent($a_Tray[$i_Ubound - 4][0], "SetDessus")
	TrayItemSetState($a_Tray[$i_Ubound - 4][0], 4 - 3 * $Dessus)
	$a_Tray[$i_Ubound - 3][0] = TrayCreateItem($s_LangMini, $a_Tray[$i_Ubound - 6][0])
	TrayItemSetOnEvent($a_Tray[$i_Ubound - 3][0], "SetMini")
	TrayItemSetState($a_Tray[$i_Ubound - 3][0], 4 - 3 * $Mini)
	$a_Tray[$i_Ubound - 2][0] = TrayCreateItem("")
	$a_Tray[$i_Ubound - 1][0] = TrayCreateItem($s_LangExit)
	TrayItemSetOnEvent($a_Tray[UBound($a_Tray) - 1][0], "Exuit")
	TrayTip("", "", 0)
EndFunc   ;==>Main
Func Recharge() ;mise  jour de la fentre principale
	Main()
EndFunc   ;==>Recharge
Func FenActive($f_Temporaire = -1) ;action  faire sur la fentre demande
	Local $a_WinGetState = WinGetState($f_Temporaire)
	If BitAND($a_WinGetState, 8) Then ;Active
		If BitAND($a_WinGetState, 16) Then ;Minimise
			WinSetState($f_Temporaire, "", @SW_RESTORE) ;Restaure
		Else ;BitAnd($a_WinGetState, 32) ;Maximise ou Restaure
			WinSetState($f_Temporaire, "", @SW_MINIMIZE) ;Minimise
		EndIf
	Else ;Inactive
		WinActivate($f_Temporaire) ;Active
	EndIf
EndFunc   ;==>FenActive
Func Fenetre($f_Temporaire = 0, $i_Abs = 1500, $i_Ord = 750, $i_Width = 400, $i_Height = 65, $i_State = 0x84CF8000) ;affichage de la fentre dsire
	;0x84CF8000 = BitOR(0x80000000, 0xC00000, 0x10000, 0x20000, 0x40000, 0x8000) = WS_POPUP+WS_CAPTION+WS_MAXIMIZEBOX+WS_MINIMIZEBOX+WS_SIZEBOX+WS_SYSMENU
	TrayTip(@ScriptName, $s_LangChargeFenetre, 0)
	Local $a_ProcessGetWindows, $c_Temporaire, $c_MenuTemporaire, $i_TextHeight = 20, $i_Decalage = 0, $i = 0, $j, $l, $i_Ubound = UBound($a_WinProc) - 1, $f_GUI = $f_Temporaire
	If $i_Ubound < 2 Then $i_Ubound = -1
	If $f_Temporaire = 0 Then
		$f_GUI = GUICreate("nAiO - " & $MODULE_NOM, $i_Width + 1, $i_Height + ($i_Ubound + 1) * $i_TextHeight, $i_Abs, $i_Ord, $i_State, 0x80 * $Mini + 0x8 * $Dessus)
		GUISetOnEvent(-3, "exuit", $f_GUI)
		If $Debug = 1 Then GUISetState()
		$c_Temporaire = GUICtrlCreateButton("RP-Box", 0, $i_Decalage + 0, $i_Width * 1 / 5, $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "RPBox")
		GUICtrlSetTip($c_Temporaire, "Permet de prparer des messages  envoyer  une fentre.")
		$c_Temporaire = GUICtrlCreateButton($s_LangReorganisation, $i_Width * 1 / 5, $i_Decalage + 0, $i_Width * 1 / 5, $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "Reorganise")
		GUICtrlSetTip($c_Temporaire, "Rorganise les fentres sur l'cran.")
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangRaccourcis, $i_Width * 2 / 5, $i_Decalage + 0 * $i_TextHeight, $i_Width * 1 / 5, $i_TextHeight)
		GUICtrlSetState($c_Temporaire, 4 - $Shortcut * 3)
		GUICtrlSetOnEvent($c_Temporaire, "SetShortcut")
		GUICtrlSetTip($c_Temporaire, $s_LangTipRaccourcis)
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangInitiatives, $i_Width * 3 / 5, $i_Decalage + 0 * $i_TextHeight, $i_Width * 1 / 5, $i_TextHeight)
		GUICtrlSetState($c_Temporaire, 4 - $Init * 3)
		GUICtrlSetOnEvent($c_Temporaire, "SetInit")
		GUICtrlSetTip($c_Temporaire, $s_LangTipInitiatives)
		$c_Temporaire = GUICtrlCreateButton($s_LangConfigure, $i_Width * 4 / 5, $i_Decalage + 0 * $i_TextHeight, $i_Width * 1 / 5, $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "SetConfig")
		GUICtrlSetTip($c_Temporaire, $s_LangTipConfigure)
		$c_Temporaire = GUICtrlCreateButton($s_LangRafraichir, 0, $i_Decalage + (2 + $i_Ubound + 1) * $i_TextHeight, $i_Width * 2 / 8, 1.25 * $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "Recharge")
		GUICtrlSetTip($c_Temporaire, $s_LangTipRafraichir)
		$c_Temporaire = GUICtrlCreateButton($s_LangEnregistrer, $i_Width * 2 / 8, $i_Decalage + (2 + $i_Ubound + 1) * $i_TextHeight, $i_Width * 1.5 / 8, 1.25 * $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "HotSave")
		GUICtrlSetTip($c_Temporaire, $s_LangTipEnregistrer)
		$c_Temporaire = GUICtrlCreateButton($s_LangCharger, $i_Width * 3.5 / 8, $i_Decalage + (2 + $i_Ubound + 1) * $i_TextHeight, $i_Width * 1.5 / 8, 1.25 * $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "HotLoad")
		GUICtrlSetTip($c_Temporaire, $s_LangTipCharger)
		If $i_Ubound > 1 Then
			$c_Temporaire = GUICtrlCreateLabel($s_LangTextePrincipal, 0, $i_Decalage + 1 * $i_TextHeight, $i_Width, $i_TextHeight)
			GUICtrlSetOnEvent($c_Temporaire, "SetConfig")
			GUICtrlSetTip($c_Temporaire, $s_LangTipTextePrincipal)
			$c_Temporaire = GUICtrlCreateButton($s_LangBoutonPrecedent, $i_Width * 5.25 / 8, $i_Decalage + (2 + $i_Ubound + 1) * $i_TextHeight, $i_Width * 0.75 / 8, 1.25 * $i_TextHeight)
			GUICtrlSetOnEvent($c_Temporaire, "HotProcPrec")
			GUICtrlSetTip($c_Temporaire, $s_LangTipBoutonPrecedent)
			$c_Temporaire = GUICtrlCreateButton($s_LangBoutonSuivant, $i_Width * 6 / 8, $i_Decalage + (2 + $i_Ubound + 1) * $i_TextHeight, $i_Width * 0.75 / 8, 1.25 * $i_TextHeight)
			GUICtrlSetOnEvent($c_Temporaire, "HotProcSuiv")
			GUICtrlSetTip($c_Temporaire, $s_LangTipBoutonSuivant)
			While $i <= $i_Ubound
				$l = $a_WinProc[$i][0]
				If $Shortcut = 1 Then
					For $j = 0 To $i_Ubound - 1
						If $j <> $i And $a_WinProc[$j][0] = $a_WinProc[$i][0] Then
							$l = $a_WinProc[$i][2]
							ExitLoop
						EndIf
					Next
				EndIf
				If $l = "" Then $l = "NaN"
				$c_Temporaire = GUICtrlCreateLabel(StringReplace($l, "&", "&&") & " :", 0, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 2 / 8, $i_TextHeight)
				GUICtrlSetOnEvent($c_Temporaire, "HotCtrl")
				$c_MenuTemporaire = GUICtrlCreateContextMenu($c_Temporaire)
				$a_WinProc[$i][17] = GUICtrlCreateMenuItem($s_LangMenuActiverFenetre, $c_MenuTemporaire, 0)
				GUICtrlSetOnEvent($a_WinProc[$i][17], "HotCtrl")
				$a_WinProc[$i][18] = GUICtrlCreateMenuItem($s_LangMenuCopierFenetre, $c_MenuTemporaire, 1)
				GUICtrlSetOnEvent($a_WinProc[$i][18], "FenClip")
				GUICtrlSetTip($c_Temporaire, $s_LangTipActiverFenetre & " [" & $a_WinProc[$i][0] & "] :" & @CRLF & "~" & $a_WinProc[$i][2] & "~")
				$a_WinProc[$i][15] = $c_Temporaire
				If $Shortcut = 1 Then
					$l = $a_WinProc[$i][4]
					If $l = "" Then $l = "NaN"
					$c_Temporaire = GUICtrlCreateButton(StringReplace($l, "&", "&&"), $i_Width * 2 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetOnEvent($c_Temporaire, "KeyGet")
					GUICtrlSetTip($c_Temporaire, $s_LangAffecterRaccourci & @CRLF & "~" & $a_WinProc[$i][2] & "~")
					$a_WinProc[$i][5] = $c_Temporaire
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangControle, $i_Width * 3 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetOnEvent($c_Temporaire, "KeyMod")
					GUICtrlSetState($c_Temporaire, $a_WinProc[$i][6])
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherRaccourcis & " " & $s_LangControle & " + [" & $a_WinProc[$i][4] & "]")
					$a_WinProc[$i][10] = $c_Temporaire
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangAlternative, $i_Width * 4 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetOnEvent($c_Temporaire, "KeyMod")
					GUICtrlSetState($c_Temporaire, $a_WinProc[$i][7])
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherRaccourcis & " " & $s_LangAlternative & " + [" & $a_WinProc[$i][4] & "]")
					$a_WinProc[$i][11] = $c_Temporaire
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangShift, $i_Width * 5 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetOnEvent($c_Temporaire, "KeyMod")
					GUICtrlSetState($c_Temporaire, $a_WinProc[$i][8])
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherRaccourcis & " " & $s_LangShift & " + [" & $a_WinProc[$i][4] & "]")
					$a_WinProc[$i][12] = $c_Temporaire
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangWindows, $i_Width * 6 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetOnEvent($c_Temporaire, "KeyMod")
					GUICtrlSetState($c_Temporaire, $a_WinProc[$i][9])
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherRaccourcis & " " & $s_LangWindows & " + [" & $a_WinProc[$i][4] & "]")
					$a_WinProc[$i][13] = $c_Temporaire
				Else
					If $i < $i_Ubound - 1 Then
						If $Init Then
							$c_Temporaire = GUICtrlCreateLabel($a_WinProc[$i][2], $i_Width * 2 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 5 / 8, $i_TextHeight)
						Else
							$c_Temporaire = GUICtrlCreateLabel($a_WinProc[$i][2], $i_Width * 2 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 6 / 8, $i_TextHeight)
						EndIf
						GUICtrlSetOnEvent($c_Temporaire, "void")
					EndIf
;~ 					GUICtrlSetOnEvent($c_Temporaire, "Void")
				EndIf
				If $i = $i_Ubound - 1 Then
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangDessus, $i_Width * 7 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetState($c_Temporaire, 4 - $Dessus * 3)
					GUICtrlSetOnEvent($c_Temporaire, "SetDessus")
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherOption & ' "' & $s_LangDessus & '" ' & $s_LangTipOptionDessus)
				ElseIf $i = $i_Ubound Then
					$c_Temporaire = GUICtrlCreateCheckbox($s_LangMini, $i_Width * 7 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
					GUICtrlSetState($c_Temporaire, 4 - $Mini * 3)
					GUICtrlSetOnEvent($c_Temporaire, "SetMini")
					GUICtrlSetTip($c_Temporaire, $s_LangTipCocherOption & ' "' & $s_LangMini & '" ' & $s_LangTipOptionMini)
				Else
					If $Init = 1 Then
						$c_Temporaire = GUICtrlCreateInput($a_WinProc[$i][16], $i_Width * 7 / 8, $i_Decalage + (2 + $i) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
						GUICtrlSetOnEvent($c_Temporaire, "InitWrite")
						GUICtrlSetTip($c_Temporaire, $s_LangTipOptionInitiatives & " ~" & $a_WinProc[$i][2] & "~." & @CRLF & $s_LangTipNaN)
						$a_WinProc[$i][14] = $c_Temporaire
					EndIf
				EndIf
				$i += 1
			WEnd
		Else
			$c_Temporaire = GUICtrlCreateLabel($s_LangTexteSecondaireDebut & " " & StringReplace($s_Processus, ";", " ou ") & $s_LangTexteSecondaireFin, 0, $i_Decalage + 1 * $i_TextHeight, $i_Width, $i_TextHeight)
			GUICtrlSetOnEvent($c_Temporaire, "Recharge")
			GUICtrlSetTip($c_Temporaire, $s_LangTipRafraichir)
			$c_Temporaire = GUICtrlCreateCheckbox($s_LangDessus, $i_Width * 5 / 8, $i_Decalage + (2 + $i_Ubound + 1.125) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
			GUICtrlSetState($c_Temporaire, 4 - $Dessus * 3)
			GUICtrlSetOnEvent($c_Temporaire, "SetDessus")
			GUICtrlSetTip($c_Temporaire, $s_LangTipCocherOption & ' "' & $s_LangDessus & '" ' & $s_LangTipOptionDessus)
			$c_Temporaire = GUICtrlCreateCheckbox($s_LangMini, $i_Width * 6 / 8, $i_Decalage + (2 + $i_Ubound + 1.125) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
			GUICtrlSetState($c_Temporaire, 4 - $Mini * 3)
			GUICtrlSetOnEvent($c_Temporaire, "SetMini")
			GUICtrlSetTip($c_Temporaire, $s_LangTipCocherOption & ' "' & $s_LangMini & '" ' & $s_LangTipOptionMini)
		EndIf
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangAuto, $i_Width * 7 / 8, $i_Decalage + (2 + $i_Ubound + 1.125) * $i_TextHeight, $i_Width * 1 / 8, $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "SetAuto")
		GUICtrlSetTip($c_Temporaire, $s_LangTipAuto)
		GUICtrlSetState($c_Temporaire, 4 - $Auto * 3)
		$i_Decalage = (2 + $i_Ubound + 1) * $i_TextHeight + 25 ; C'est la taille de la somme des blocs plus haut
		$c_Temporaire = GUICtrlCreateLabel($s_LangReorganisation & " : ", 0, $i_Decalage + $i_TextHeight / 8, $i_Width * 1 / 4, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipReorganisation)
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangReorganiseFenetre, $i_Width * 1 / 4, $i_Decalage, $i_Width * 1 / 4, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipReorganiseFenetre)
		GUICtrlSetState($c_Temporaire, 4 - 3 * $AutoWin)
		GUICtrlSetOnEvent($c_Temporaire, "SetReorgFenetre")
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangSuivanteProc, $i_Width * 2 / 4, $i_Decalage, $i_Width * 1 / 4, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipSuivanteProc)
		GUICtrlSetState($c_Temporaire, 4 - 3 * $AutoSuiv)
		GUICtrlSetOnEvent($c_Temporaire, "SetReorgSuiv")
		$c_Temporaire = GUICtrlCreateCheckbox($s_LangPrecedenteProc, $i_Width * 3 / 4, $i_Decalage, $i_Width * 1 / 4, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipPrecedenteProc)
		GUICtrlSetState($c_Temporaire, 4 - 3 * $AutoPrec)
		GUICtrlSetOnEvent($c_Temporaire, "SetReorgPrec")
		$c_Temporaire = GUICtrlCreateLabel($s_LangProcessus, 0, $i_Decalage + $i_TextHeight, $i_Width * 1 / 3, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipProcessus)
		$c_Temporaire = GUICtrlCreateList("", 0, $i_Decalage + $i_TextHeight * 2, $i_Width * 1 / 3, 5 * $i_TextHeight)
		$a_ProcessGetWindows = ProcessGetWin(256)
		$l = "" ;Ne pas oublier l'initialisation !
		For $i = 1 To $a_ProcessGetWindows[0][0] - 1
			;ajouter ici une fonction de masque des processus sans fentres.
			If $a_ProcessGetWindows[$i][0] <> StringTrimLeft($l, StringInStr($l, "|", 2, -1)) Then $l &= "|" & $a_ProcessGetWindows[$i][0] ;ok |
		Next
		GUICtrlSetData($c_Temporaire, $l)
		GUICtrlSetOnEvent($c_Temporaire, "ListAddProc")
		GUICtrlSetTip($c_Temporaire, $s_LangTipProcessus)
		$a_Controls[0] = $c_Temporaire
		$c_Temporaire = GUICtrlCreateEdit($s_Processus, $i_Width * 1 / 3, $i_Decalage + $i_TextHeight * 3, $i_Width * 1 / 3, 3 * $i_TextHeight, 0x1104)
		GUICtrlSetOnEvent($c_Temporaire, "ListSet")
		GUICtrlSetTip($c_Temporaire, $s_LangTipListProcDebut & @CRLF & $s_LangTipListProcFin)
		$a_Controls[1] = $c_Temporaire
		$c_Temporaire = GUICtrlCreateLabel($s_LangProcessusAcceptes, $i_Width * 2 / 3, $i_Decalage + $i_TextHeight, $i_Width * 1 / 3, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipProcessusAcceptes)
		$c_Temporaire = GUICtrlCreateList("", $i_Width * 2 / 3, $i_Decalage + $i_TextHeight * 2, $i_Width * 1 / 3, 5 * $i_TextHeight)
		GUICtrlSetData($c_Temporaire, StringReplace($s_Processus, ";", "|"))
		GUICtrlSetOnEvent($c_Temporaire, "ListDelProc")
		GUICtrlSetTip($c_Temporaire, $s_LangTipProcessusAcceptes)
		$a_Controls[2] = $c_Temporaire
		$c_Temporaire = GUICtrlCreateLabel($s_LangFenetres, 0, $i_Decalage + $i_TextHeight * 7, $i_Width * 1 / 2, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipFenetres)
		$c_Temporaire = GUICtrlCreateList("", 1, $i_Decalage + $i_TextHeight * 8, $i_Width * 1 / 2, 5 * $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "ListAddBlack")
		GUICtrlSetTip($c_Temporaire, $s_LangTipFenetres)
		$a_Controls[3] = $c_Temporaire
		$c_Temporaire = GUICtrlCreateLabel($s_LangFenetresIgnorees, $i_Width * 1 / 2, $i_Decalage + $i_TextHeight * 7, $i_Width * 1 / 2, $i_TextHeight)
		GUICtrlSetTip($c_Temporaire, $s_LangTipFenetresIgnorees)
		$c_Temporaire = GUICtrlCreateList("", $i_Width * 1 / 2, $i_Decalage + $i_TextHeight * 8, $i_Width * 1 / 2, 5 * $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "ListDelBlack")
		GUICtrlSetTip($c_Temporaire, $s_LangTipFenetresIgnorees)
		$a_Controls[4] = $c_Temporaire
		GUISetState()
	EndIf
	If $Config = 1 Then
		WinSetClientSize($f_GUI, "", $i_Width, $i_Height + (1 + $i_Ubound) * $i_TextHeight)
	ElseIf $Config = 4 Then
		WinSetClientSize($f_GUI, "", $i_Width, $i_Height + (1 + $i_Ubound) * $i_TextHeight + 13 * $i_TextHeight - 3)
	EndIf
	TrayTip("", "", 0)
	Return $f_GUI
EndFunc   ;==>Fenetre
Func ChargeLang($IniLang, $s_Lang)
	$s_LangChargeModule = IniRead($IniLang, $s_Lang, "trayChargeModule", "Chargement du module...")
	$s_LangChargeFenetre = IniRead($IniLang, $s_Lang, "trayChargeFenetre", "Mise en place de la fentre...")
	$s_LangSuivanteWin = IniRead($IniLang, $s_Lang, "texteFenetreSuivante", "(Suivante)")
	$s_LangSuivanteProc = IniRead($IniLang, $s_Lang, "texteProcessusSuivant", "Suivante")
	$s_LangPrecedenteWin = IniRead($IniLang, $s_Lang, "texteFenetrePrecedente", "(Prcdente)")
	$s_LangPrecedenteProc = IniRead($IniLang, $s_Lang, "texteProcessusPrecedent", "Prcdente")
	$s_LangConfigure = IniRead($IniLang, $s_Lang, "texteConfiguration", "Configuration")
	$s_LangTipConfigure = IniRead($IniLang, $s_Lang, "tipConfiguration", "Permet de choisir les processus  chercher, ainsi que les fentres  ignorer.")
	$s_LangAuto = IniRead($IniLang, $s_Lang, "texteAuto", "Auto")
	$s_LangDessus = IniRead($IniLang, $s_Lang, "texteDessus", "Dessus")
	$s_LangTipOptionDessus = IniRead($IniLang, $s_Lang, "tipDessus", "place la fentre du module sur le devant.")
	$s_LangMini = IniRead($IniLang, $s_Lang, "texteMini", "Mini")
	$s_LangTipOptionMini = IniRead($IniLang, $s_Lang, "tipMini", "rend le module plus discret.")
	$s_LangExit = IniRead($IniLang, $s_Lang, "texteSortie", "Exit")
	$s_LangReorganisation = IniRead($IniLang, $s_Lang, "texteReorganisation", "Rorganisation")
	$s_LangRaccourcis = IniRead($IniLang, $s_Lang, "texteRaccourcis", "Raccourcis")
	$s_LangTipRaccourcis = IniRead($IniLang, $s_Lang, "tipBoutonRaccourci", "Affiche les raccourcis du clavier associs aux fentres.")
	$s_LangInitiatives = IniRead($IniLang, $s_Lang, "texteInitiatives", "Initiatives")
	$s_LangTipInitiatives = IniRead($IniLang, $s_Lang, "tipInitiatives", "Montre les initiatives des fentres.")
	$s_LangRafraichir = IniRead($IniLang, $s_Lang, "texteRafraichir", "Rafrachir")
	$s_LangTipRafraichir = IniRead($IniLang, $s_Lang, "tipRafraichir", "Met  jour la fentre.")
	$s_LangEnregistrer = IniRead($IniLang, $s_Lang, "texteEnregistrer", "Enregistrer")
	$s_LangTipEnregistrer = IniRead($IniLang, $s_Lang, "tipEnregistrer", "Sauvegarde l'tat de la fentre.")
	$s_LangCharger = IniRead($IniLang, $s_Lang, "texteCharger", "Charger")
	$s_LangTipCharger = IniRead($IniLang, $s_Lang, "tipCharger", "Recharge l'tat de la fentre.")
	$s_LangTextePrincipal = IniRead($IniLang, $s_Lang, "textePrincipal", "Choisissez la fentre  placer au premier plan :")
	$s_LangTipTextePrincipal = IniRead($IniLang, $s_Lang, "tipPtincipal", "Cliquez ici pour ouvrir la configuration.")
	$s_LangBoutonPrecedent = IniRead($IniLang, $s_Lang, "textePrecedent", "<")
	$s_LangTipBoutonPrecedent = IniRead($IniLang, $s_Lang, "tipPrecedent", "Activer la fentre prcdente dans l'ordre de priorit.")
	$s_LangBoutonSuivant = IniRead($IniLang, $s_Lang, "texteSuivant", ">")
	$s_LangTipBoutonSuivant = IniRead($IniLang, $s_Lang, "tipSuivant", "Activer la fentre suivante dans l'ordre de priorit.")
	$s_LangMenuActiverFenetre = IniRead($IniLang, $s_Lang, "texteMenuFenetre", "Activer cette fentre")
	$s_LangMenuCopierFenetre = IniRead($IniLang, $s_Lang, "texteMenuCopie", "Copier le nom dans le presse-papier")
	$s_LangTipActiverFenetre = IniRead($IniLang, $s_Lang, "tipFenetre", "Cliquez ici pour activer la fentre")
	$s_LangAffecterRaccourci = IniRead($IniLang, $s_Lang, "tipBoutonRaccourci", "Dsigne la touche-raccourci pour activer la fentre")
	$s_LangControle = IniRead($IniLang, $s_Lang, "texteControle", "Ctrl")
	$s_LangShift = IniRead($IniLang, $s_Lang, "texteShift", "Shift")
	$s_LangAlternative = IniRead($IniLang, $s_Lang, "texteAlternative", "Alt")
	$s_LangWindows = IniRead($IniLang, $s_Lang, "texteWindows", "Win")
	$s_LangTipCocherOption = IniRead($IniLang, $s_Lang, "tipCocherLaCase", "Cocher la case")
	$s_LangTipCocherRaccourcis = IniRead($IniLang, $s_Lang, "tipCocherRaccourcis", "Cochez cette case pour utiliser")
	$s_LangTipOptionInitiatives = IniRead($IniLang, $s_Lang, "tipOptionInitiatives", "Ordre de priorit de la fentre")
	$s_LangTipNaN = IniRead($IniLang, $s_Lang, "tipNaN", "Entrez NaN pour ignorer.")
	$s_LangTexteSecondaireDebut = IniRead($IniLang, $s_Lang, "tipSecondaireDebut", "Veuillez ouvrir une fentre")
	$s_LangTexteSecondaireFin = IniRead($IniLang, $s_Lang, "tipSecondaireFin", ", svp.")
	$s_LangTipAuto = IniRead($IniLang, $s_Lang, "tipAuto", "Sauvegarde automatiquement les modifications (quand la case est coche).")
	$s_LangTipReorganisation = IniRead($IniLang, $s_Lang, "tipReorganisation", "Gestion de la rorganisation automatique des fentres.")
	$s_LangReorganiseFenetre = IniRead($IniLang, $s_Lang, "texteReorganisationFenetre", "Fentre")
	$s_LangTipReorganiseFenetre = IniRead($IniLang, $s_Lang, "tipReorganisationFenetre", "Automatiquement rorganiser en passant par la fentre.")
	$s_LangTipSuivanteProc = IniRead($IniLang, $s_Lang, "tipReorganisationSuivante", "Automatiquement rorganiser en passant  la Suivante.")
	$s_LangTipPrecedenteProc = IniRead($IniLang, $s_Lang, "tipReorganisationPrecedente", "Automatiquement rorganiser en passant  la Prcdente.")
	$s_LangProcessus = IniRead($IniLang, $s_Lang, "texteProcessus", "Processus :")
	$s_LangTipProcessus = IniRead($IniLang, $s_Lang, "tipProcessus", "Ceci est la liste des processus disponibles, cliquez pour ajouter.")
	$s_LangTipListProcDebut = IniRead($IniLang, $s_Lang, "tipListProcessusDebut", "Voici la recherche des processus qui sera faite, vous pouvez la modifier")
	$s_LangTipListProcFin = IniRead($IniLang, $s_Lang, "tipListProcessusFin", "en ajoutant des noms  la main, spars par "";"".")
	$s_LangProcessusAcceptes = IniRead($IniLang, $s_Lang, "texteAcceptes", "Accepts :")
	$s_LangTipProcessusAcceptes = IniRead($IniLang, $s_Lang, "tipAcceptes", "Ceci est la liste des processus qui seront recherchs, cliquez pour retirer.")
	$s_LangFenetres = IniRead($IniLang, $s_Lang, "texteFenetre", "Fentres :")
	$s_LangTipFenetres = IniRead($IniLang, $s_Lang, "tipListFenetre", "Ceci est la liste des fentres associes au processus, cliquez pour black-lister.")
	$s_LangFenetresIgnorees = IniRead($IniLang, $s_Lang, "texteIgnores", "Ignores :")
	$s_LangTipFenetresIgnorees = IniRead($IniLang, $s_Lang, "tipIgnores", "Ceci est la liste des fentres black-listes, cliquez pour ds-ignorer.")
EndFunc   ;==>ChargeLang
Func PosFenetre($f_Temporaire = "", $i = 1, $j = 0) ;position de la fentre demande, aprs sauvegarde/chargement
	Dim $a_PosF[4], $a_Temporaire[2]
	If $j = 0 Then ;Chargement
		If $i = 1 Then ;du fichier
			$a_PosF[0] = IniRead($Ini, "Position", "Horizontale", -1)
			$a_PosF[1] = IniRead($Ini, "Position", "Verticale", -1)
			$a_PosF[2] = IniRead($Ini, "Position", "Lageur", 400)
			$a_PosF[3] = IniRead($Ini, "Position", "Hauteur", 65)
		Else
			If $f_Temporaire = "" Then ;de la fentre par dfaut
				$a_PosF[0] = -1
				$a_PosF[1] = -1
				$a_PosF[2] = 400
				$a_PosF[3] = 65
			Else ;de la fentre existante
				If BitAND(WinGetState($f_Temporaire), 16) Then WinSetState($f_Temporaire, "", @SW_RESTORE)
				$a_PosF = WinGetPos($f_Temporaire)
				$a_Temporaire = WinGetClientSize($f_Temporaire)
				$a_PosF[2] = $a_Temporaire[0]
				$a_PosF[3] = $a_Temporaire[1]
			EndIf
		EndIf
	Else ;Sauvegarde
		If $i = 1 Then ;du fichier
			If $f_Temporaire <> "" Then
				If BitAND(WinGetState($f_Temporaire), 16) Then WinSetState($f_Temporaire, "", @SW_RESTORE)
				$a_PosF = WinGetPos($f_Temporaire)
				$a_Temporaire = WinGetClientSize($f_Temporaire)
				$a_PosF[2] = $a_Temporaire[0]
				$a_PosF[3] = $a_Temporaire[1]
				IniWrite($Ini, "Position", "Horizontale", $a_PosF[0])
				IniWrite($Ini, "Position", "Verticale", $a_PosF[1])
				IniWrite($Ini, "Position", "Lageur", $a_PosF[2])
				IniWrite($Ini, "Position", "Hauteur", $a_PosF[3])
			EndIf
		Else
			If $f_Temporaire = "" Then ;de la fentre par dfaut
				$a_PosF[0] = -1
				$a_PosF[1] = -1
			Else ;de la fentre existante
				If BitAND(WinGetState($f_Temporaire), 16) Then WinSetState($f_Temporaire, "", @SW_RESTORE)
				$a_PosF = WinGetPos($f_Temporaire)
				$a_Temporaire = WinGetClientSize($f_Temporaire)
				$a_PosF[2] = $a_Temporaire[0]
				$a_PosF[3] = $a_Temporaire[1]
			EndIf
		EndIf
	EndIf
	Return $a_PosF
EndFunc   ;==>PosFenetre
Func FenClip()
	Local $i, $i_CtrlId = @GUI_CtrlId, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $i_CtrlId = $a_WinProc[$i][18] Then
			ClipPut($a_WinProc[$i][2])
			ExitLoop
		EndIf
	Next
EndFunc   ;==>FenClip
Func HotCtrl() ;bouton de fentre cliqu
	Local $i, $i_CtrlId = @GUI_CtrlId, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $i_CtrlId = $a_WinProc[$i][15] Or $i_CtrlId = $a_WinProc[$i][17] Then
			HotFunc($i, $i_Ubound)
			ExitLoop
		EndIf
	Next
EndFunc   ;==>HotCtrl
Func HotFunc($composante = 0, $max = 0, $phase = 0) ;Activation de la fentre dsire sur raccourcis
	Local $i, $j = -1, $r = 0, $i_Ubound = UBound($a_WinProc) - 1
	$i = $a_WinProc[$i_Ubound - 1][16]
	If $composante = $max - 1 Then ;Suivante
		$j = ProcSuiv($i, $a_WinProc)
		If $AutoSuiv = 1 Then $r = 1
	ElseIf $composante = $max Then ;Prcdente
		$j = ProcPrec($i, $a_WinProc)
		If $AutoPrec = 1 Then $r = 1
	Else
		$j = $composante + $phase
		If $AutoWin = 1 And $a_WinProc[$j][16] <> "NaN" Then $r = 1
	EndIf
	If $j > -1 Then ;Si la fentre demande existe
		$a_WinProc[$i_Ubound - 1][16] = $j
		$a_WinProc[$i_Ubound][16] = $j
		FenActive($a_WinProc[$j][3])
		If $r = 1 Then Reorganise()
	EndIf
EndFunc   ;==>HotFunc
Func HotKey() ;touche de fentre appuye
	Local $i, $i_CtrlId = @HotKeyPressed, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $i_CtrlId = Key($i) Then
			HotFunc($i, $i_Ubound)
			ExitLoop
		EndIf
	Next
EndFunc   ;==>HotKey
Func HotLoad() ;rechargement de la fentre principale
	Main(1)
EndFunc   ;==>HotLoad
Func HotProcPrec() ;lien vers la fonction en OnEvent
	HotFunc()
EndFunc   ;==>HotProcPrec
Func HotProcSuiv() ;lien vers la fonction en OnEvent
	HotFunc(-1)
EndFunc   ;==>HotProcSuiv
Func HotRead() ;chargement des touche-raccourcis
	Local $i, $s_Raccourci
	For $i = 0 To UBound($a_WinProc) - 1
		$s_Raccourci = IniRead($Ini, $a_WinProc[$i][0], "." & $a_WinProc[$i][2], "{}")
		$a_WinProc[$i][6] = ""
		If StringInStr($s_Raccourci, "^") > 0 Then $a_WinProc[$i][6] = 1
		$a_WinProc[$i][7] = ""
		If StringInStr($s_Raccourci, "!") > 0 Then $a_WinProc[$i][7] = 1
		$a_WinProc[$i][8] = ""
		If StringInStr($s_Raccourci, "+") > 0 Then $a_WinProc[$i][8] = 1
		$a_WinProc[$i][9] = ""
		If StringInStr($s_Raccourci, "#") > 0 Then $a_WinProc[$i][9] = 1
		$s_Raccourci = StringTrimLeft($s_Raccourci, StringInStr($s_Raccourci, "{"))
		$s_Raccourci = StringLeft($s_Raccourci, StringLen($s_Raccourci) - 1)
		$a_WinProc[$i][4] = $s_Raccourci
	Next
EndFunc   ;==>HotRead
Func HotSave() ;sauvegarde de la fentre principale
	Local $i, $i_Ubound = UBound($a_WinProc) - 1
	DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
	For $i = 0 To $i_Ubound
		IniWrite($Ini, $a_WinProc[$i][0], "." & $a_WinProc[$i][2], Key($i))
	Next
	InitSave()
	IniWrite($Ini, "Configuration", "Config", $Config)
	IniWrite($Ini, "Configuration", "Dessus", $Dessus)
	IniWrite($Ini, "Configuration", "Init", $Init)
	IniWrite($Ini, "Configuration", "Mini", $Mini)
	IniWrite($Ini, "Configuration", "Shortcut", $Shortcut)
	IniWrite($Ini, "Configuration", "AutoWin", $AutoWin)
	IniWrite($Ini, "Configuration", "AutoSuiv", $AutoSuiv)
	IniWrite($Ini, "Configuration", "AutoPrec", $AutoPrec)
	PosFenetre($Fenetre, 1, 1)
EndFunc   ;==>HotSave
Func HotTray() ;ligne du traytool clique
	Local $i, $i_CtrlId = @TRAY_ID, $i_Ubound = UBound($a_Tray) - 8
	TrayItemSetState($i_CtrlId, 4)
	For $i = 2 To $i_Ubound
		If $i_CtrlId = $a_Tray[$i][0] Then
			HotFunc($i, $i_Ubound, -2)
			ExitLoop
		EndIf
	Next
EndFunc   ;==>HotTray
Func InitRead() ;chargement de l'ordre de priorit des fentres /!\! IniRead en masse ici !/!\
	Local $i, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		$a_WinProc[$i][16] = IniRead($Ini, $a_WinProc[$i][0], "." & $a_WinProc[$i][2] & "-Init", "")
	Next
EndFunc   ;==>InitRead
Func InitSave() ;sauvegarde de l'ordre de priorit des fentres /!\! IniWrite en masse ici !/!\
	Local $i, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		IniWrite($Ini, $a_WinProc[$i][0], "." & $a_WinProc[$i][2] & "-Init", GUICtrlRead($a_WinProc[$i][14]))
	Next
EndFunc   ;==>InitSave
Func InitWrite() ;mise  jour de l'ordre de priorit des fentres
	Local $i_CtrlID = @GUI_CtrlId, $i, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $a_WinProc[$i][14] = $i_CtrlID Then
			$a_WinProc[$i][16] = GUICtrlRead($i_CtrlID)
			ExitLoop
		EndIf
	Next
	If $Auto = 1 Then
		InitSave()
	EndIf
EndFunc   ;==>InitWrite
Func Key($key) ;mise en forme du raccourcis
	Local $s = ""
	If $a_WinProc[$key][6] = 1 Then $s &= "^"
	If $a_WinProc[$key][7] = 1 Then $s &= "!"
	If $a_WinProc[$key][8] = 1 Then $s &= "+"
	If $a_WinProc[$key][9] = 1 Then $s &= "#"
	If $a_WinProc[$key][4] <> "" Then $s &= "{" & $a_WinProc[$key][4] & "}"
	Return $s
EndFunc   ;==>Key
Func KeyGet() ;choix du raccourcis
	Local $i_CtrlId = @GUI_CtrlId, $i, $s_Raccourci, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $a_WinProc[$i][5] = $i_CtrlId Then
			$s_Raccourci = InputBox(@ScriptName, "Entrez le nom de la touche que vous dsirez associer  la fentre " & $a_WinProc[$i][2] & " :", $a_WinProc[$i][4], "", 250, 200, (@DesktopWidth - 250) / 2, (@DesktopHeight - 200) / 2, 0, $Fenetre)
			If @error = 0 Then
				KeySet()
				$a_WinProc[$i][4] = $s_Raccourci
				If $Auto = 1 Then HotSave()
				Recharge()
			EndIf
			ExitLoop
		EndIf
	Next
EndFunc   ;==>KeyGet
Func KeyMod() ;mise  jour du modificateur du raccourcis
	Local $i_CtrlId = @GUI_CtrlId, $i, $j, $i_Ubound = UBound($a_WinProc) - 1
	KeySet()
	For $i = 0 To $i_Ubound
		For $j = 10 To 13 ;Attention  ces valeurs 10  13 !
			If $a_WinProc[$i][$j] = $i_CtrlId Then $a_WinProc[$i][$j - 4] = GUICtrlRead($i_CtrlId)
		Next
	Next
	KeySet("HotKey")
	If $Auto = 1 Then HotSave()
EndFunc   ;==>KeyMod
Func KeySet($f_Temporaire = "") ;(ds-)activation des HotKeys sur la fonction choisie
	Local $i, $i_Ubound = UBound($a_WinProc) - 1
	For $i = 0 To $i_Ubound
		If $f_Temporaire <> "" Then
			HotKeySet(Key($i), $f_Temporaire)
		Else
			HotKeySet(Key($i))
		EndIf
	Next
EndFunc   ;==>KeySet
Func ListAddBlack() ;ajout de la fentre  la liste noire
	Local $a_BlackListe, $i, $s_Control = GUICtrlRead($a_Controls[3]), $i_Found = 0
	$a_BlackListe = StringSplit($s_BlackListe, ";", 2)
	While $i < UBound($a_BlackListe) And $i_Found = 0
		If $a_BlackListe[$i] = $s_Control Then $i_Found = 1
		$i += 1
	WEnd
	If $i_Found = 0 Then
		$s_BlackListe &= ";" & $s_Control
		If $Auto = 1 Then IniWrite($Ini, "Configuration", "BlackListe", $s_BlackListe)
		ListFen()
	EndIf
EndFunc   ;==>ListAddBlack
Func ListAddProc() ;ajout du processus en liste de recherche
	Local $a_ProcessListe, $i, $s_Control = GUICtrlRead($a_Controls[0]), $i_Found = 0
	$a_ProcessListe = StringSplit($s_Processus, ";", 2)
	While $i < UBound($a_ProcessListe) And $i_Found = 0
		If $a_ProcessListe[$i] = $s_Control Then $i_Found = 1
		$i += 1
	WEnd
	If $i_Found = 0 Then
		If $s_Processus <> "" Then $s_Processus &= ";"
		$s_Processus &= $s_Control
	EndIf
	GUICtrlSetData($a_Controls[2], "")
	GUICtrlSetData($a_Controls[2], StringReplace($s_Processus, ";", "|"))
	GUICtrlSetData($a_Controls[1], $s_Processus)
	If $Auto = 1 Then IniWrite($Ini, "Configuration", "Processus", $s_Processus)
	ListFen()
EndFunc   ;==>ListAddProc
Func ListDelBlack() ;suppression de la fentre de la liste noire
	Local $a_BlackListe, $i, $j, $s_Control = GUICtrlRead($a_Controls[4]), $s_Temporaire = ""
	$a_BlackListe = StringSplit($s_BlackListe, ";", 2)
	While $i < UBound($a_BlackListe)
		If $a_BlackListe[$i] <> $s_Control Then $s_Temporaire &= $a_BlackListe[$i] & ";"
		$i += 1
	WEnd
	$s_BlackListe = $s_Temporaire
	If $Auto = 1 Then IniWrite($Ini, "Configuration", "BlackListe", $s_BlackListe)
	ListFen()
EndFunc   ;==>ListDelBlack
Func ListDelProc() ;suppression du processus de la liste de recherche
	Local $a_ProcessListe, $i, $j, $s_Control = GUICtrlRead($a_Controls[2]), $s_Temporaire = ""
	$a_ProcessListe = StringSplit($s_Processus, ";", 2)
	While $i < UBound($a_ProcessListe) ;Recherche de la position de l'lment
		If $a_ProcessListe[$i] <> $s_Control Then
			If $a_ProcessListe[$i] <> "" And $s_Temporaire <> "" Then $s_Temporaire &= ";"
			$s_Temporaire &= $a_ProcessListe[$i]
		EndIf
		$i += 1
	WEnd
	$s_Processus = $s_Temporaire
	GUICtrlSetData($a_Controls[2], "")
	GUICtrlSetData($a_Controls[2], StringReplace($s_Processus, ";", "|"))
	GUICtrlSetData($a_Controls[1], $s_Processus)
	If $Auto = 1 Then IniWrite($Ini, "Configuration", "Processus", $s_Processus)
	ListFen()
EndFunc   ;==>ListDelProc
Func ListFen() ;mise  jour de la liste des fentres et de la liste noire en fonction du processus
	Local $a_ProcessGetWindows, $i, $s_Temporaire = "", $s_Secondaire = ""
	$a_ProcessGetWindows = ProcessGetWin(4, GUICtrlRead($a_Controls[0]))
	For $i = 1 To UBound($a_ProcessGetWindows) - 1
		If $a_ProcessGetWindows[$i][2] <> "" Then
			If StringInStr($s_BlackListe, $a_ProcessGetWindows[$i][2]) = 0 Then
				$s_Temporaire &= "|" & $a_ProcessGetWindows[$i][2]
			ElseIf StringInStr($s_Secondaire, $a_ProcessGetWindows[$i][2]) = 0 Then
				$s_Secondaire &= "|" & $a_ProcessGetWindows[$i][2]
			EndIf
		EndIf
	Next
	GUICtrlSetData($a_Controls[3], $s_Temporaire) ;Mise  jour de la zone d'Edit
	GUICtrlSetData($a_Controls[4], $s_Secondaire) ;Mise  jour de la ListView
EndFunc   ;==>ListFen
Func ListSet() ;mise  jour de la liste de recherche
	$s_Processus = GUICtrlRead($a_Controls[1])
	GUICtrlSetData($a_Controls[2], "")
	GUICtrlSetData($a_Controls[2], StringReplace($s_Processus, ";", "|"))
	If $Auto = 1 Then IniWrite($Ini, "Configuration", "Processus", $s_Processus)
EndFunc   ;==>ListSet
Func SetAuto() ;action du bouton Auto
	$Auto = 1 - $Auto
	DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
	IniWrite($Ini, "Configuration", "Auto", $Auto)
EndFunc   ;==>SetAuto
Func SetConfig() ;ouverture de la slection des processus
	Local $a_PosF = PosFenetre($Fenetre, 0, $Auto)
	$Config = 1 + (4 - $Config)
	If $Config = 0 Then $Config = 1
	If $Config = 5 Then $Config = 4
	If $Auto = 1 Then HotSave()
	Fenetre($Fenetre, $a_PosF[0], $a_PosF[1], $a_PosF[2])
EndFunc   ;==>SetConfig
Func SetDessus() ;action du bouton Dessus
	$Dessus = 1 - $Dessus
	WinSetOnTop($Fenetre, "", $Dessus) ;Berk
;~ 	GUISetStyle(0x84CF8000, 0x8 * $Dessus, $Fenetre) ;0x8 n'est pas valable.. t_t
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "Dessus", $Dessus)
	EndIf
EndFunc   ;==>SetDessus
Func SetInit()
	$Init = 1 - $Init
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "Init", $Init)
	EndIf
	Recharge()
EndFunc   ;==>SetInit
Func SetMini() ;action du bouton Mini
	Local $a_StyleF, $a_PosF, $a_Temporaire
	$Mini = 1 - $Mini
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "Mini", $Mini)
	EndIf
	$a_StyleF = GUIGetStyle($Fenetre) ;Attention au "0x10000000" !
	GUISetStyle($a_StyleF[0] - 0x10000000, 0x80 * $Mini, $Fenetre) ;Attention, il y a 1 pixels dans toutes les directions en supplment en mode Mini !
EndFunc   ;==>SetMini
Func SetReorgFenetre()
	$AutoWin = 1 - $AutoWin
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "AutoWin", $AutoWin)
	EndIf
EndFunc   ;==>SetReorgFenetre
Func SetReorgPrec()
	$AutoPrec = 1 - $AutoPrec
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "AutoPrec", $AutoPrec)
	EndIf
EndFunc   ;==>SetReorgPrec
Func SetReorgSuiv()
	$AutoSuiv = 1 - $AutoSuiv
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "AutoSuiv", $AutoSuiv)
	EndIf
EndFunc   ;==>SetReorgSuiv
Func SetShortcut()
	$Shortcut = 1 - $Shortcut
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "Configuration", "Shortcut", $Shortcut)
	EndIf
	Recharge()
EndFunc   ;==>SetShortcut
Func ProcPrec($f_Origine, ByRef $a_ProcessusGeneraux, $Col = 16) ;choix de la fentre prcdente
	Local $p = 0, $destination, $cible, $sDestination, $sCible, $sTemp, $i_Ubound = UBound($a_ProcessusGeneraux) - 1, $i = $i_Ubound - 2
	$cible = $f_Origine
	$destination = $f_Origine
	If $cible < 0 Then ;traiter  l'envers
		$destination = $i
		For $i = $cible To -1 Step 1
			$destination = ProcSuiv($destination, $a_ProcessusGeneraux)
		Next
	Else
		While $i >= 0 And $p = 0
			$sTemp = $a_ProcessusGeneraux[$i][$Col]
			If $sTemp <> "NaN" Then
				$sDestination = $a_ProcessusGeneraux[$destination][$Col]
				While StringLen($sDestination) > StringLen($sTemp)
					$sTemp = " " & $sTemp
				WEnd
				While StringLen($sDestination) < StringLen($sTemp)
					$sDestination = " " & $sDestination
				WEnd
				If $sTemp < $sDestination Then ;chercher plus petit
					$sCible = $a_ProcessusGeneraux[$cible][$Col]
					While StringLen($sCible) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					While StringLen($sCible) < StringLen($sTemp)
						$sCible = " " & $sCible
					WEnd
					If $sCible < $sTemp Or $cible = $destination Then
						$cible = $i
					EndIf
				ElseIf $sTemp = $sDestination And $i < $destination Then ;chercher en priorit gal plus haut
					$cible = $i
					$p = 1
				EndIf
			EndIf
			$i -= 1
		WEnd
		If $cible <> $destination Then ;trouv juste plus petit, sans gal plus haut
			$destination = $cible
		Else ;on doit chercher soit plus grand, soit reprendre de la fin un gal
			$p = -1
			$i = $i_Ubound - 2
			While $i >= 0 ;trouv ni plus petit, ni gal plus haut
				$sTemp = $a_ProcessusGeneraux[$i][$Col]
				If $sTemp <> "NaN" Then
					$sCible = $a_ProcessusGeneraux[$cible][$Col]
					While StringLen($sCible) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					$sDestination = $a_ProcessusGeneraux[$destination][$Col]
					While StringLen($sDestination) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					While StringLen($sDestination) < StringLen($sTemp)
						$sDestination = " " & $sDestination
					WEnd
					While StringLen($sCible) < StringLen($sTemp)
						$sCible = " " & $sCible
					WEnd
					If $sTemp > $sCible Then ;trouv le plus grand lment
						$cible = $i
					ElseIf $p = -1 And $sTemp = $sDestination Then
						$p = $i
					EndIf
				EndIf
				$i -= 1
			WEnd
			If $cible <> $destination Then
				$destination = $cible
			Else ;toujours rien trouv
				$destination = $p
			EndIf
		EndIf
	EndIf
	Return $destination ;[Valeur]
EndFunc   ;==>ProcPrec
Func ProcSuiv($f_Origine, ByRef $a_ProcessusGeneraux, $Col = 16) ;choix de la fentre suivante
	Local $i, $p = 0, $destination, $cible, $sDestination, $sCible, $sTemp, $i_Ubound = UBound($a_ProcessusGeneraux) - 1, $cible
	$cible = $f_Origine
	$destination = $f_Origine
	If $cible < 0 Then ;traiter  l'envers
		$destination = $i
		For $i = $cible To -1 Step 1
			$destination = ProcPrec($destination, $a_ProcessusGeneraux)
		Next
	Else
		While $i <= $i_Ubound - 2 And $p = 0
			$sTemp = $a_ProcessusGeneraux[$i][$Col]
			If $sTemp <> "NaN" Then
				$sDestination = $a_ProcessusGeneraux[$destination][$Col]
				While StringLen($sDestination) > StringLen($sTemp)
					$sTemp = " " & $sTemp
				WEnd
				While StringLen($sDestination) < StringLen($sTemp)
					$sDestination = " " & $sDestination
				WEnd
				If $sTemp > $sDestination Then ;chercher plus grand
					$sCible = $a_ProcessusGeneraux[$cible][$Col]
					While StringLen($sCible) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					While StringLen($sCible) < StringLen($sTemp)
						$sCible = " " & $sCible
					WEnd
					If $sCible > $sTemp Or $cible = $destination Then
						$cible = $i
					EndIf
				ElseIf $sTemp = $sDestination And $i > $destination Then ;chercher en priorit gal plus bas
					$cible = $i
					$p = 1
				EndIf
			EndIf
			$i += 1
		WEnd
		If $cible <> $destination Then ;trouv juste plus grand, sans gal plus bas
			$destination = $cible
		Else ;on doit chercher soit plus petit, soit reprendre du dbut un gal
			$p = -1
			$i = 0
			While $i <= $i_Ubound - 2 ;trouv ni plus grand, ni gal plus bas
				$sTemp = $a_ProcessusGeneraux[$i][$Col]
				If $sTemp <> "NaN" Then
					$sCible = $a_ProcessusGeneraux[$cible][$Col]
					While StringLen($sCible) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					$sDestination = $a_ProcessusGeneraux[$destination][$Col]
					While StringLen($sDestination) > StringLen($sTemp)
						$sTemp = " " & $sTemp
					WEnd
					While StringLen($sDestination) < StringLen($sTemp)
						$sDestination = " " & $sDestination
					WEnd
					While StringLen($sCible) < StringLen($sTemp)
						$sCible = " " & $sCible
					WEnd
					If $sTemp < $sCible Then ;trouv le plus petit lment
						$cible = $i
					ElseIf $p = -1 And $sTemp = $sDestination Then
						$p = $i
					EndIf
				EndIf
				$i += 1
			WEnd
			If $cible <> $destination Then
				$destination = $cible
			Else ;toujours rien trouv
				$destination = $p
			EndIf
		EndIf
	EndIf
	Return $destination ;[Valeur]
EndFunc   ;==>ProcSuiv
Func Exuit() ;sortie du module
	PosFenetre($Fenetre, $Auto, 1)
	If $Fenetre <> "" Then GUIDelete($Fenetre)
	Exit
EndFunc   ;==>Exuit
Func void() ;fonction de test de raction des objets
	If $Debug Then MsgBox(80, "Hmm, erreur : Fonction vide.", "Ce bouton (" & @GUI_CtrlId & ") contenant '" & GUICtrlRead(@GUI_CtrlId) & "' n'a pas d'action associe." & @CRLF & @CRLF & "Merci de me signaler l'objet sur lequel vous avez cliqu et ce que vous auriez aim que a fasse pour que je l'ajoute !" & @CRLF & "Za.")
EndFunc   ;==>void
Func pause()
	$pause = 1-$pause
	While $pause
	WEnd
EndFunc
#EndRegion Functions
#Region Reorganisation
#cs ;[obsolte]Test de rorganisation des fentres.
Func Reorganise_tst()
	Local $i, $j, $k, $aZone, $a_PosF, $aPosZF, $MoyZ
	Dim $aZone[1][4]
	$k = ProcPrec(ProcSuiv($a_WinProc[UBound($a_WinProc) - 2][16], $a_WinProc), $a_WinProc) ;Normalement, a retourne $k sans fentre "NaN"
	$j = $k;ProcSuiv($k, $a_WinProc)
	$i = 1
	Do
		$aZone[0][0] = $i
		ReDim $aZone[$i + 1][4]
		$a_PosF = WinGetPos($a_WinProc[$j][3])
		$aPosZF = ReorganiZone($a_PosF[2], $a_PosF[3])
		$aZone[$i][0] = WinGetTitle($a_WinProc[$j][3])
		$aZone[$i][1] = $aPosZF[0]
		$aZone[$i][2] = $a_PosF[2]
		$aZone[$i][3] = $a_PosF[3]
		$MoyZ += $aPosZF[0]
		$i += 1
		$j = ProcSuiv($j, $a_WinProc)
	Until $j = $k
	$MoyZ /= ($i - 1)
	$i = 0
	$j = 0
	$k = 1
	While $i + $k < $aZone[0][0] - 1
		$i = 0
		$j = 0
		While $j < 4
			$j += $aZone[$i + $k][1]
			$i += 1
		WEnd
		$k += $i - 1
	WEnd

	_ArrayDisplay($aZone, $MoyZ)
EndFunc   ;==>Reorganise_tst
#ce
Func Reorganise() ;Attention aux fentres de taille haute qui font sortir les autres de l'cran !
	TrayTip(@ScriptName, "Rorganisation des fentres...", 0)
	Local $a_ListFen, $a_ZonePrimaire, $a_ZoneSecondaire, $i_xSecondaire, $i_ySecondaire, $i_xZone = @DesktopWidth, $i_yZone = @DesktopHeight, _
			$a_Rapport, $a_PosF, $i, $j, $k, $a_ListFen, $i_xCible, $i_yCible, $i_Balises
	Dim $a_ZoneSecondaire[1][4]
	Dim $a_ListFen[2], $a_Rapport[3]
	$a_ListFen[0] = 1
	$a_ListFen[1] = ProcPrec(ProcSuiv($a_WinProc[UBound($a_WinProc) - 2][16], $a_WinProc), $a_WinProc)
	If $a_ListFen[1] = -1 Or Not WinExists($a_WinProc[$a_ListFen[1]][3]) Then Return 0
	For $i = 1 To UBound($a_WinProc) - 3 ;Parcours de la liste des fentres
		$j = ProcSuiv($a_ListFen[$a_ListFen[0]], $a_WinProc) ;passage  la fentre suivante
		If $j = $a_ListFen[1] Then ;jusqu' retourner  la premire
			ExitLoop
		ElseIf WinExists($a_WinProc[$j][3]) Then
			$a_ListFen[0] += 1 ;on l'ajoute  la liste des fentres  rorganiser
			ReDim $a_ListFen[$a_ListFen[0] + 1]
			$a_ListFen[$a_ListFen[0]] = $j
		EndIf
	Next
	$a_Rapport = Decoupe($a_ListFen[0]) ;Nombre de colonnes
	$i_Balises = $a_Rapport[0] - $a_ListFen[0] ;Nombre de fentres supplmentaires vides

	$i_xSecondaire = $i_xZone * ($a_Rapport[2] / (3 + $a_Rapport[2])) ;On obtient une zone progressive dynamique en secondaire
	$a_PosF = WinGetPos($a_WinProc[$a_ListFen[1]][3])
	$a_ZonePrimaire = ReorganiZone($a_PosF[2], $a_PosF[3], $i_xZone - $i_xSecondaire, $i_yZone) ;On prvoit la taille de la fentre principale
	If $a_ZonePrimaire[1] < $i_xZone - $i_xSecondaire Then $i_xSecondaire = $i_xZone - $a_ZonePrimaire[1] ;Si la rsolution est favorable (fentre haute), on prvoit de s'taler sur le secondaire.
	$i_xCible = $i_xSecondaire; + ($i_xZone - $i_xSecondaire - $a_ZonePrimaire[1]) / 2 ;Position X de la fentre princpale
	$i_yCible = 0; + ($i_yZone - $a_ZonePrimaire[2]) / 2 ;Position Y de la fentre principale
	WinMove($a_WinProc[$a_ListFen[1]][3], "", $i_xCible, $i_yCible, $a_ZonePrimaire[1], $a_ZonePrimaire[2], 1) ;Dplacement de la fentre principale
;~ 	MsgBox(0, "WinMove", "Title : " & WinGetTitle($a_WinProc[$k][3]) & ", X : " & $i_xCible & ", Y : " & $i_yCible & ", L ; " & $a_ZonePrimaire[1] & ", H : " & $a_ZonePrimaire[2])
	If $a_ListFen[0] > 1 Then ;Si il y a au-moins 2 fentres
		$j = 1
		Do ;Recherche du meilleur ratio pour les fentres
			$a_ZoneSecondaire[0][0] = $j
			ReDim $a_ZoneSecondaire[$a_ZoneSecondaire[0][0] + 1][4]
			$a_PosF = WinGetPos($a_WinProc[$a_ListFen[$j + 1]][3])
			$a_PosF = ReorganiZone($a_PosF[2], $a_PosF[3], $i_xSecondaire / $a_Rapport[2], $i_yZone)
			$a_ZoneSecondaire[$j][0] = $a_PosF[1] ;Hauteur prvisible de la fentre
			$a_ZoneSecondaire[$j][1] = $a_PosF[2] ;Largeur prvisible de la fentre
			$a_ZoneSecondaire[$j][2] = $a_WinProc[$a_ListFen[$j + 1]][3]
;~ 			$a_ZoneSecondaire[$j][3] = WinGetState($a_WinProc[$a_ListFen[$j + 1]][3])
			$j += 1
		Until $j >= $a_ListFen[0]
		$k = 0 ;Zone Y secondaire
		While $k < $a_Rapport[2] ;Mise en place des colonnes
;~ 			MsgBox(0,$k,"Ok jusque-l.")
			$i_xCible = $i_xSecondaire * $k / $a_Rapport[2]; + ($i_xSecondaire / $a_Rapport[2] - $a_ZoneSecondaire[$j + $k][0]) / 2 ;base + (zone-prise)/2
			$i_yCible = 0 ;Position Y de base de la rduite
			For $j = 1 To $a_Rapport[1] ;Revoir le systme de gestion de la taille des fentres dans la zone secondaire, elle ne s'adapte pas au nombre de fentres qui vont tre dans la pile. (Exemple : colonnes de 3 et 4 fentres)
				If ($j + $k * $a_Rapport[1]) < ($a_Rapport[0] - $i_Balises) And $a_ZoneSecondaire[$j + $k * $a_Rapport[1]][2] <> $a_WinProc[$a_ListFen[1]][3] Then ;Si ce n'est pas la fentre principale
					WinMove($a_ZoneSecondaire[$j + $k * $a_Rapport[1]][2], "", $i_xCible, $i_yCible, $a_ZoneSecondaire[$j + $k * $a_Rapport[1]][0], $a_ZoneSecondaire[$j + $k * $a_Rapport[1]][1], 1)
					WinActivate($a_ZoneSecondaire[$j + $k * $a_Rapport[1]][2])
;~ 					MsgBox(0, "WinMove", "Title : " & WinGetTitle($a_ZoneSecondaire[$j + $k][2]) & ", X : " & $i_xCible & ", Y : " & $i_yCible & ", L ; " & $a_ZoneSecondaire[$j + $k][0] & ", H : " & $a_ZoneSecondaire[$j + $k][1])
					$i_yCible += $a_ZoneSecondaire[$j + $k * $a_Rapport[1]][1]
;~ 					$i_yCible = ($j - 1) * ($i_yZone / $a_Rapport[1]) ;Position Y de base de la rduite
;~ 					$i_yCible = ($j - 1) * ($i_yZone / (Round(($a_ZoneSecondaire[0][0]- $k) / $i))); + ($i_yZone / (Round(($a_ZoneSecondaire[0][0]- $k) / $i)) - $a_ZoneSecondaire[$j + $k][1]) / 2
					;...
				EndIf
			Next
;~ 			If $k = 0 And $a_ZoneSecondaire[0][0] / 2 <> Int($a_ZoneSecondaire / 2) Then $a_Rapport[1] -= 1
			$k += 1
		WEnd
		FenActive($a_WinProc[$a_ListFen[1]][3])
	EndIf
	TrayTip("", "", 0)
EndFunc   ;==>Reorganise
Func ReorganiZone($i_lOrig, $i_hOrig, $i_lCible = 0, $i_hCible = 0) ;Limiter la taille en hauteur d'ici ?
	Local $a_ReorganiZone
	Dim $a_ReorganiZone[3]
	If IsArray($i_lOrig) Then
		If IsArray($i_hOrig) Then
			$i_lCible = $i_hOrig[0]
			$i_hCible = $i_hOrig[1]
			$i_hOrig = $i_lOrig[2]
			$i_lOrig = $i_lOrig[3]
		Else
			$i_hCible = $i_lCible
			$i_lCible = $i_hOrig
			$i_hOrig = $i_lOrig[3]
			$i_lOrig = $i_lOrig[2]
		EndIf
	ElseIf IsArray($i_hOrig) Then
		$i_hCible = $i_hOrig[1]
		$i_lCible = $i_hOrig[2]
		$i_hOrig = 0
	EndIf
	If $i_lCible <= 0 And $i_hCible <= 0 Then
		$a_ReorganiZone[0] = $i_hOrig / $i_lOrig
		$a_ReorganiZone[1] = $i_lOrig
		$a_ReorganiZone[2] = $i_hOrig
	Else
		If $i_lOrig > 0 Then $a_ReorganiZone[0] = $i_lCible / $i_lOrig
		If $i_hOrig > 0 Then
			If $i_hCible / $i_hOrig < $a_ReorganiZone[0] Then $a_ReorganiZone[0] = $i_hCible / $i_hOrig
		EndIf
		$a_ReorganiZone[1] = $a_ReorganiZone[0] * $i_lOrig
		$a_ReorganiZone[2] = $a_ReorganiZone[0] * $i_hOrig
	EndIf
	Return $a_ReorganiZone
EndFunc   ;==>ReorganiZone
Func Decoupe($z) ;Nombre de fentres  dcouper
	Dim $a_Decoupe[3] = [$z, 0, 0]
	Do
		$a_Decoupe[2] += 1 ;Y
	Until Round($a_Decoupe[0]/$a_Decoupe[2]) < $a_Decoupe[2] ;On cherche le meilleur nombre de fentres par colonnes
	$a_Decoupe[2] -= 1 ;pour rcuprer un nombre cohrent
	$a_Decoupe[1] = Round($a_Decoupe[0]/$a_Decoupe[2]) ;X
	Return $a_Decoupe ;retour du nombre de lignes/colonnes
EndFunc
#EndRegion Reorganisation
#Region RP_Box
Func RPBox()
	Local $i_TextHeight = 21, $i_Width = 250, $i = 0, $s_ComboWin = "NaN", $a_PosF, $c_Temporaire
	$a_PosF = PosFenetre($Fenetre, 0, 0)
	If $f_FenetreSecondaire = "" Then ;crer la fentre
		$f_FenetreSecondaire = GUICreate($MODULE_NOM & " - RP-Box", $i_Width, $i_TextHeight * (3 * ($i + 1) + 2), $a_PosF[0], $a_PosF[1], -1, -1, $Fenetre)
		GUISetOnEvent(-3, "WindowExit")
		$c_Temporaire = GUICtrlCreateLabel("Fentre	[V]", 0, $i_TextHeight, $i_Width * 2 / 8, $i_TextHeight)
		$c_Temporaire = GUICtrlCreateLabel("Message : ", $i_Width * 2 / 8, $i_TextHeight, $i_Width * 6 / 8, $i_TextHeight)
		$RPBoxCheckboxCensure = GUICtrlCreateCheckbox("Censure : ", 0, 0, $i_Width * 2 / 8, $i_TextHeight)
		GUICtrlSetState($c_Temporaire, 5 - 3 * $RPBoxCensoreMode)
		GUICtrlSetOnEvent($c_Temporaire, "RPBox_CensoreMode")
		GUICtrlSetTip($RPBoxCheckboxCensure, "Activer la censure sur les mots ci-contre.")
		$RPBoxInputCensure = GUICtrlCreateInput("http;://;www;&#;  ;ass;tits;rape", $i_Width * 2 / 8, 0, $i_Width * 4 / 8, $i_TextHeight)
		GUICtrlSetTip($RPBoxInputCensure, "Entrez ici la liste des mots que vous dsirez d-censurer.")
		$c_Temporaire = GUICtrlCreateCheckbox("Flash", $i_Width * 6 / 8, 0, $i_Width * 2 / 8, $i_TextHeight)
		GUICtrlSetState($c_Temporaire, 5 - 3 * $RPBoxFlashMode)
		GUICtrlSetOnEvent($c_Temporaire, "RPBox_FlashMode")
		GUICtrlSetTip($c_Temporaire, "Active le mode de transformation des caractres spciaux pour les applications Flash.")
		$RPBoxComboPrefix = GUICtrlCreateCombo("", 0, $i_TextHeight * ($i * 3 + 2), $i_Width * 2 / 8, $i_TextHeight)
		GUICtrlSetData($RPBoxComboPrefix, "/NaN|/w |/g |/p |/b |/m |/r |/t |/a |/d |/fear ", "/NaN")
		GUICtrlSetTip($RPBoxComboPrefix, "Choisissez la partie  ajouter devant le message. (/NaN pour ignorer)")
		$RPBoxComboWin = GUICtrlCreateCombo("", 0, $i_TextHeight * ($i * 3 + 3), $i_Width * 2 / 8, $i_TextHeight)
		For $j = 0 To UBound($a_WinProc) - 1
			$s_ComboWin &= "|" & $a_WinProc[$j][2]
		Next
		GUICtrlSetData($RPBoxComboWin, $s_ComboWin, "NaN")
		GUICtrlSetTip($RPBoxComboWin, "Choisissez la fentre de destintion pour le message. (NaN pour ignorer)")
		$RPBoxEdit = GUICtrlCreateEdit("", $i_Width * 2 / 8, $i_TextHeight * ($i * 3 + 2), $i_Width * 6 / 8, $i_TextHeight * 3)
		GUICtrlSetTip($RPBoxEdit, "Prparez ici le message  envoyer. Si le bouton Flash est coch," & @CRLF & "les caractres spciaux seront automatiquement adapts.")
		$c_Temporaire = GUICtrlCreateButton("Envoi", 0, $i_TextHeight * ($i * 3 + 4), $i_Width * 2 / 8, $i_TextHeight)
		GUICtrlSetOnEvent($c_Temporaire, "RPBox_Send")
		GUICtrlSetTip($c_Temporaire, "Activer la fentre choisie pour y placer le texte.")

		GUISetState()
	Else
		WindowExit()
	EndIf
EndFunc
Func RPBox_CensoreMode()
	$RPBoxCensoreMode = 1 - $RPBoxCensoreMode
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "RP_Box", "Censure", $RPBoxCensoreMode)
	EndIf
EndFunc
Func RPBox_FlashMode()
	$RPBoxFlashMode = 1 - $RPBoxFlashMode
	If $Auto = 1 Then
		DirCreate(StringLeft($Ini, StringInStr($Ini, "\", 0, -1) - 1))
		IniWrite($Ini, "RP_Box", "Flash", $RPBoxFlashMode)
	EndIf
EndFunc
Func RPBox_Send()
	Local $s_WinTitle = GUICtrlRead($RPBoxComboWin), $s_Prefix = GUICtrlRead($RPBoxComboPrefix), $s_Message = GUICtrlRead($RPBoxEdit), $s_Temporaire = "", $s_Cut = ""
	If $s_WinTitle = "NaN" Then $s_WinTitle = ""
	If $s_Prefix = "/NaN" Then $s_Prefix = ""
	If $RPBoxFlashMode = 1 Then
		If $RPBoxCensoreMode = 0 Then
			$s_Message = textForFlash($s_Message, GUICtrlRead($RPBoxInputCensure))
		Else
			$s_Message = textForFlash($s_Message)
		EndIf
	Else
		If $RPBoxCensoreMode = 0 Then $s_Message = uncensore($s_Message, GUICtrlRead($RPBoxInputCensure))
	EndIf
	$RPText = $s_Prefix & $s_Message
	TrayTip(@ScriptName, "Vous pouvez maintenant insrer le texte dans la fentre. (Appuyez sur la touche Insert.)" & @CRLF & $RPText, 7)
	WinActivate($s_WinTitle)
EndFunc
Func SendClip()
	Local $i = 0
	If $RPText = "" Then
		HotKeySet("{INS}")
		Send("{INS}")
		HotKeySet("{INS}", "SendClip")
	Else
		While $i < StringLen($RPText) - 190
			ClipPut(StringTrimLeft(StringLeft($RPText, $i + 190), $i))
			Send("^{v}")
			Send("{ENTER}")
			Sleep(1234)
			$i += 190
		WEnd
		ClipPut(StringTrimLeft(StringLeft($RPText, $i + 190), $i))
		Send("^{v}")
		$RPText = ""
	EndIf
EndFunc
Func WindowExit() ;Fermeture de la fentre supplmentaire [ rcuprer pour la RP-Box]
	If $f_FenetreSecondaire <> "" Then
		GUIDelete($f_FenetreSecondaire)
		$f_FenetreSecondaire = ""
	EndIf
EndFunc   ;==>WindowExit
#EndRegion RP_Box
#Region UserDefined
Func textForFlash($s, $s_Censure = "", $s_CenseChar = Default)
	Local $i = 1, $a_Temporaire, $s_Temporaire = ""
	If $s_CenseChar = Default Then $s_CenseChar = Chr(127)
	;D-censurisation + passage en array
	$a_Temporaire = StringSplit(uncensore($s, $s_Censure, $s_CenseChar), "", 0)
	For $i = 1 To $a_Temporaire[0]
		Switch $a_Temporaire[$i] ;Il tait un fois, a c'est trs original. :)
			Case " ", "a", "b", "c", "d","e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "&", '"', "'", "-", "_", "#", ",", ";", ":", "!", "?", ".", "/", "\", "%", "*", "$", "^", "@"
				$s_Temporaire &= $a_Temporaire[$i]
			Case @CR
			Case Else
				$s_Temporaire &= "&#" & Asc($a_Temporaire[$i]) & ";" ;Huhu, c'est suffisant. ^^
		EndSwitch
	Next
	If $s_Temporaire = "" Then $s_Temporaire = $s
	Return $s_Temporaire
EndFunc
Func uncensore($s, $s_List = "", $s_Censure = Default) ;Mwhahaha
	Local $i, $s_Temporaire = $s, $a_Temporaire = StringSplit($s_List, ";")
	If $s_Censure = Default Then $s_Censure = Chr(127)
	For $i = 1 To $a_Temporaire[0]
		$s_Temporaire = StringReplace($s_Temporaire, $a_Temporaire[$i], StringLeft($a_Temporaire[$i], 1) & $s_Censure & StringTrimLeft($a_Temporaire[$i], 1))
	Next
	Return $s_Temporaire
EndFunc
Func arraySort(ByRef $array, $start="", $end="")
	; Initialisation
	If Not (IsInt($start) And IsInt($end)) Then
			$start = 0
			$end = UBound($array)-1
	EndIf
	; Anti-condition d'arrt
	If $end > $start Then
		; Le milieu du tableau sert de pivot
		Local $start2=$start, $end2=$end, $middle = Int(($start2+$end2)/2), $pivot = $array[$middle][0]
		Do
			; On parcourt la partie de gauche en fonction du pivot
			While (compare($array[$start2][0], $pivot) < 0)
				$start2 += 1
			WEnd
			; Idem pour la partie de droite
			While (compare($array[$end2][0], $pivot) > 0)
				$end2 -= 1
			WEnd
			; Si l'quilibre n'est pas fait
			If $start2 <= $end2 Then
				; On inverse les valeurs pour obtenir des sous-tableaux en rapport avec le pivot
				For $i = 0 To UBound($array, 2) - 1
					Local $temp = $array[$start2][$i]
					$array[$start2][$i] = $array[$end2][$i]
					$array[$end2][$i] = $temp
				Next
				$start2 += 1
				$end2 -= 1
			EndIf
		; Tant que les deux parties ne sont pas quilibres
		Until $start2 > $end2
		; Appel rcursif sur la partie de gauche
		arraySort($array, $start, $end2)
		; Appel rcursif sur la partie de droite
		arraySort($array, $start2, $end)
	EndIf
EndFunc
Func compare($a, $b)
	; Pattern pour regexp
	Local $pattern = "^\d+"
	; si les valeurs sont les memes
	If $a = $b Then Return 0
	; si a commence par des nombres
	If Number($a) <> Number($b) Then Return Number($a) - Number($b)
	; On prend la chaine de taille la plus petite
	Local $sizeA = StringLen($a), $sizeB = StringLen($b), $size = $sizeA
	If $sizeB < $sizeA Then $size = $sizeB
	; On remplace tous les caractres spciaux qui risquent d'embrouiller le traitement
	Local $escapedCharacters[7] = ["a=", "e=", "i=", "o=", "u=", "y=", "n="]
	For $character In $escapedCharacters
	   Local $regexp = StringSplit($escapedCharacters,"=")
	   $a = StringRegExpReplace($a, "["&$regexp[1]&"]", $regexp[0])
	   $b = StringRegExpReplace($b, "["&$regexp[1]&"]", $regexp[0])
	Next
;~ 	$a = StringRegExpReplace($a, "[]", "a")
;~ 	$a = StringRegExpReplace($a, "[]", "e")
;~ 	$a = StringRegExpReplace($a, "[]", "i")
;~ 	$a = StringRegExpReplace($a, "[]", "o")
;~ 	$a = StringRegExpReplace($a, "[]", "u")
;~ 	$a = StringRegExpReplace($a, "[]", "y")
;~ 	$a = StringRegExpReplace($a, "[]", "n")
	; On teste les sous chaines pour isoler la plus longue commune  gauche
	For $i = 1 To $size-1
		; Si on a une diffrence
		If StringLeft($a,$i) <> StringLeft($b,$i) Then
			; On isole les chaines dont le premier caractere est diffrent ($a[$i] <> $b[$i], car pour tout $j avant $i on a galit)
			$a = StringTrimLeft($a, $i-1)
			$b = StringTrimLeft($b, $i-1)
			; Si l'un ou l'autre ne commence pas par un chiffre ce n'est pas testable en l'tat
			If Not StringRegExp($a, $pattern) Or Not StringRegExp($b, $pattern) Then ExitLoop
			; Si les conditions sont remplies, on isole les Numbers et on les comparent pour avoir le resultat
			Return Number($a)-Number($b)
		EndIf
	Next
	; Si aucun pattern n'a t trouv, on utilise un stringCompare classique
	Return StringCompare($a, $b)
EndFunc
#cs
	Func WinSetClientSize($title, $text="", $width=0, $height=0) ; Par dfaut on ne touche pas la coordonne valant 0
	Local $a_SizeWindow = WinGetPos($title, $text), $a_SizeClient = WinGetClientSize($title, $text), $coordsToApply
	$coordsToApply = $a_SizeWindow
	If $width<>0  Then $coordsToApply[2] += $width  - $a_SizeClient[0]
	If $height<>0 Then $coordsToApply[3] += $height - $a_SizeClient[1]
	WinMove($title, $text, $coordsToApply[0], $coordsToApply[1], $coordsToApply[2], $coordsToApply[3])
	EndFunc
#ce
Func WinSetClientSize($title, $text = "", $width = 0, $height = 0, $i_Mode = -1) ; Par dfaut on ne touche pas la coordonne valant 0
	; mode = -1 : Le coin haut/gauche ne bouge pas
	; mode = 0  : Le point central ne bouge pas
	; mode = 1  : Le coin bas/droite ne bouge pas
	Local $a_SizeWindow = WinGetPos($title, $text), $a_SizeClient = WinGetClientSize($title, $text), $coordsToApply
	$coordsToApply = $a_SizeWindow
	Local $deltaX = $width - $a_SizeClient[0], $deltaY = $height - $a_SizeClient[1]
	If $width <> 0 Then $coordsToApply[0] -= $deltaX * ($i_Mode + 1) / 2
	If $height <> 0 Then $coordsToApply[1] -= $deltaY * ($i_Mode + 1) / 2
	If $width <> 0 Then $coordsToApply[2] += $deltaX
	If $height <> 0 Then $coordsToApply[3] += $deltaY
	WinMove($title, $text, $coordsToApply[0], $coordsToApply[1], $coordsToApply[2], $coordsToApply[3])
EndFunc   ;==>WinSetClientSize
Func isWindowFlashing($window) ; Ecrasement des vnements si la fentre est active (cf API Windows et MSDN)
;~ 	### isWindowFlashing($window)>boolean
;~ 	Retourne une valeur True/False en fonction du clignottement ou non de la fentre
	Local $result, $structure
	If Not WinActive($window) Then ;le traitement de la fentre dj active est fait ailleurs..!
		$structure = DllStructCreate("uint;hwnd;dword;uint;dword") ; http://support.microsoft.com/kb/254339
		DllStructSetData($structure, 1, 20) ; la taille de la structure est necessaire (arbitrairement 20?)
		DllStructSetData($structure, 2, WinGetHandle($window)) ; le handle interne est necessaire
		DllStructSetData($structure, 3, 3)
		$result = DllCall("user32.dll", "int", "FlashWindowEx", "ptr", DllStructGetPtr($structure)) ; Les 3 autres paramtres (flag, count, et timeout) sont optionnels
;~ 		_ArrayDisplay($result, WinGetTitle($window)); il ne renvoie jamais un flash de la fentre.
		Return $result[0] <> 0
	EndIf
	Return False
EndFunc   ;==>isWindowFlashing
Func ProcessGetWin($i_Mode = 0, $s_ProcessGetList = "", $s_WinGetList = "") ;User-Defined function that returns the Name of a Processus and his PID with the associated Windows and their Handles in a single 1-based array
	;Mode, ProcList, WinList
	;0~32Window, +64Process
	;0Black-/1White-/2ZeroBased-/4Unique-/8IsWindow-/16ExactName-/32SortWin-
	;64Black-/128ZeroBased-/256NoWindow-/512ContainsWindow-/1024ExactName-/2048SortProc-
	Local $a_ProcessFound, $a_ProcessKeep, $a_WinFound, $a_ProcessGetWin, $a_ProcessGetList, $a_PosF, $a_WinGetList, $aTemp, $i_WinState, $i, $j, $k, $l, $i_Found, _
			$i_WhiteListWin = 1, $i_ZeroBasedWin = 2, $i_UniqueWin = 4, $i_IsWin = 8, $i_ExactNameWin = 16, $i_NoSortWin = 32, _
			$i_ProcMode = 32, $i_BlackListProc = $i_ProcMode * 2, $i_ZeroBasedProc = $i_ProcMode * 4, $i_NoWinProc = $i_ProcMode * 8, $i_ContainsWinProc = $i_ProcMode * 16, $i_ExactProc = $i_ProcMode * 32, $i_NoSortProc = $i_ProcMode * 256
	Dim $a_ProcessKeep[1][2], $a_ProcessGetWin[1][4]

	$a_ProcessGetList = StringSplit($s_ProcessGetList, ";")
	$a_WinGetList = StringSplit($s_WinGetList, ";")
	$a_ProcessFound = ProcessList()
	If Not BitAND($i_Mode, $i_NoSortProc) Then ;Not-Unsorted Processes
		Dim $a_Temporaire[$a_ProcessFound[0][0]][UBound($a_ProcessFound, 2)]
		For $i = 1 To $a_ProcessFound[0][0]
			For $j = 0 To UBound($a_ProcessFound, 2) - 1
				$a_Temporaire[$i - 1][$j] = $a_ProcessFound[$i][$j]
			Next
		Next
		_ArraySort($a_Temporaire, 0, 0)
		For $i = 1 To $a_ProcessFound[0][0]
			For $j = 0 To UBound($a_ProcessFound, 2) - 1
				$a_ProcessFound[$i][$j] = $a_Temporaire[$i - 1][$j]
			Next
		Next
	EndIf
	For $i = 1 To $a_ProcessFound[0][0] ;In the processlist
		$i_Found = 0
		$j = 1
		While $j <= $a_ProcessGetList[0] And $i_Found = 0
			If BitAND($i_Mode, $i_ExactProc) Then ;exact name
				If $a_ProcessFound[$i][0] = $a_ProcessGetList[$j] Or $a_ProcessFound[$i][1] = $a_ProcessGetList[$j] Then $i_Found = 1 ;if "process" is searched (PID or name)
			Else
				If StringInStr($a_ProcessFound[$i][0], $a_ProcessGetList[$j]) > 0 Or StringInStr($a_ProcessFound[$i][1], $a_ProcessGetList[$j]) > 0 Or $s_ProcessGetList = "" Then $i_Found = 1 ;if *process* is searched (PID or name)
			EndIf
			$j += 1
		WEnd
		If ($i_Found = 1 And Not BitAND($i_Mode, $i_BlackListProc)) Or ($i_Found = 0 And BitAND($i_Mode, $i_BlackListProc)) Then ;if (not forbidden) or (authorized)
			$a_ProcessKeep[0][0] += 1
			ReDim $a_ProcessKeep[$a_ProcessKeep[0][0] + 1][2]
			$a_ProcessKeep[$a_ProcessKeep[0][0]][0] = $a_ProcessFound[$i][0]
			$a_ProcessKeep[$a_ProcessKeep[0][0]][1] = $a_ProcessFound[$i][1]
		EndIf
	Next ;All interresting processes found

	$a_WinFound = WinList()
	ReDim $a_WinFound[$a_WinFound[0][0] + 1][UBound($a_WinFound, 2) + 1]
	If Not BitAND($i_Mode, $i_NoSortWin) Then ;SortWindows
		Dim $a_Temporaire[$a_WinFound[0][0] + 1][UBound($a_WinFound, 2)]
		For $i = 1 To $a_WinFound[0][0] - 1
			For $j = 0 To UBound($a_WinFound, 2) - 1
				$a_Temporaire[$i - 1][$j] = $a_WinFound[$i][$j]
			Next
		Next
		_ArraySort($a_Temporaire, 0, 0)
		For $i = 1 To $a_WinFound[0][0]
			For $j = 0 To UBound($a_WinFound, 2) - 1
				$a_WinFound[$i][$j] = $a_Temporaire[$i - 1][$j]
			Next
			$a_WinFound[$i][2] = WinGetProcess($a_WinFound[$i][1])
		Next
	EndIf

	For $i = 1 To $a_ProcessKeep[0][0] ;In matching processes
		For $j = 1 To $a_WinFound[0][0] ;Parmi toutes les fentres disponibles
			$i_Found = 0
			If $a_WinFound[$j][2] = $a_ProcessKeep[$i][1] Then ;ProcessOK
				$k = 1
				While $k <= $a_WinGetList[0] And $i_Found = 0
					If BitAND($i_Mode, $i_ExactNameWin) Then ;ExactWin
						If $a_WinFound[$j][0] = $a_WinGetList[$k] Or $a_WinFound[$j][1] = $a_WinGetList[$k] Then $i_Found = 1 ;Name or PID
					Else ;PartialWin
						If StringInStr($a_WinGetList[$k], $a_WinFound[$j][0]) > 0 Or StringInStr($a_WinGetList[$k], $a_WinFound[$j][1]) > 0 Then $i_Found = 1 ;Name or PID
					EndIf
					$k += 1
				WEnd
				If ($i_Found = 1 And BitAND($i_Mode, $i_WhiteListWin)) Or ($i_Found = 0 And Not BitAND($i_Mode, $i_WhiteListWin)) Then ;if (authorized) or (not forbidden)
					$i_Found = 1
					If BitAND($i_Mode, $i_IsWin) Then ;ContainsWindow
						$a_PosF = WinGetPos($a_WinFound[$j][1])
						$i_WinState = WinGetState($a_WinFound[$j][1])
						If $a_WinFound[$j][0] = "" Or Not BitAND($i_WinState, 2) Or Not IsArray($a_PosF) Or $a_PosF[2] = 0 Or $a_PosF[3] = 0 Then $i_Found = 0;!BitAND sur l'tat!
					EndIf
				Else
					$i_Found = 0
				EndIf
				If $i_Found = 1 And BitAND($i_Mode, $i_UniqueWin) Then
					$k = 1
					While $k < $j And $i_Found = 1
						If $a_WinFound[$j][0] = $a_WinFound[$k][0] Then $i_Found = 0 ; Or $a_WinFound[$j][2] = $a_WinFound[$k][2]
						$k += 1
					WEnd
				EndIf
			EndIf
			If $i_Found = 1 Then ;AddWin
				$a_ProcessGetWin[0][0] += 1
				ReDim $a_ProcessGetWin[$a_ProcessGetWin[0][0] + 1][UBound($a_ProcessGetWin, 2)]
				$a_ProcessGetWin[$a_ProcessGetWin[0][0]][0] = $a_ProcessKeep[$i][0]
				$a_ProcessGetWin[$a_ProcessGetWin[0][0]][1] = $a_ProcessKeep[$i][1]
				$a_ProcessGetWin[$a_ProcessGetWin[0][0]][2] = $a_WinFound[$j][0]
				$a_ProcessGetWin[$a_ProcessGetWin[0][0]][3] = $a_WinFound[$j][1]
			EndIf
		Next
	Next
	If BitAND($i_Mode, $i_ZeroBasedWin) Then ;OneBased
		For $i = 1 To $a_ProcessGetWin[0][0]
			For $j = 0 To UBound($a_ProcessGetWin, 2) - 1
				$a_ProcessGetWin[$i - 1][$j] = $a_ProcessGetWin[$i][$j]
			Next
		Next
		If UBound($a_ProcessGetWin) > 1 Then ReDim $a_ProcessGetWin[UBound($a_ProcessGetWin) - 1][UBound($a_ProcessGetWin, 2)]
	EndIf
	Return $a_ProcessGetWin ;ProcName|PId|WinName|WinHndl
EndFunc   ;==>ProcessGetWin
#EndRegion UserDefined
#Region Skinner
#cs **********************************
	Fonctions de base de la modlisation
#ce **********************************
Func SkinNew($type = "gui", $create = Default)
	Local $elem[3][2] = [ _
			["id", 0], _
			["type", $type], _
			["create", $create] _
			]
	Return $elem
EndFunc   ;==>SkinNew

Func SkinSet(ByRef $elem, $attrib, $value)
	Local $index = -1, $taille = UBound($elem, 1)
	; On regarde si l'attribut a dj t dfini
	For $i = 0 To $taille - 1
		If $elem[$i][0] = $attrib Then $index = $i
	Next
	; Si oui, on le modifie
	If $index <> -1 Then
		$elem[$index][1] = $value
	Else ; Sinon on l'ajoute
		ReDim $elem[$taille + 1][2]
		$elem[$taille][0] = $attrib
		$elem[$taille][1] = $value
	EndIf
EndFunc   ;==>SkinSet

Func SkinGet($elem, $attrib)
	Local $taille = UBound($elem, 1)
	; On regarde si l'attribut a dj t dfini
	For $i = 0 To $taille - 1
		If $elem[$i][0] = $attrib Then Return $elem[$i][1]
	Next
	Return Default
EndFunc   ;==>SkinGet

#cs **********************************
	Fonctions annexes de la modlisation
#ce **********************************
Func SkinSetData(ByRef $elem, $data = Default, $default = Default)
	SkinSet($elem, "setdata", 1)
	SkinSet($elem, "data", $data)
	SkinSet($elem, "defaultdata", $default)
EndFunc   ;==>SkinSetData

Func SkinSetPos(ByRef $elem, $x = Default, $y = Default)
	SkinSet($elem, "left", $x)
	SkinSet($elem, "top", $y)
EndFunc   ;==>SkinSetPos

Func SkinSetSize(ByRef $elem, $w = Default, $h = Default)
	SkinSet($elem, "width", $w)
	SkinSet($elem, "height", $h)
EndFunc   ;==>SkinSetSize

Func SkinSetPlace(ByRef $elem, $x = Default, $y = Default, $w = Default, $h = Default)
	SkinSet($elem, "setpos", 1)
	SkinSetPos($elem, $x, $y)
	SkinSetSize($elem, $w, $h)
EndFunc   ;==>SkinSetPlace

Func SkinSetStyles(ByRef $elem, $style = Default, $exstyle = Default)
	SkinSet($elem, "setstyle", 1)
	SkinSet($elem, "style", $style)
	SkinSet($elem, "exstyle", $exstyle)
EndFunc   ;==>SkinSetStyles

Func SkinSetText(ByRef $elem, $text = Default, $title = Default)
	SkinSet($elem, "text", $text)
	SkinSet($elem, "title", $title)
EndFunc   ;==>SkinSetText

Func SkinSetState(ByRef $elem, $state = Default)
	SkinSet($elem, "setstate", 1)
	SkinSet($elem, "state", $state)
EndFunc   ;==>SkinSetState

#cs ***********************************
	Fonctions de base de l'implmentation
#ce ***********************************
Func skinner(ByRef $elem)
	Local $dimension = UBound($elem, 0), $i_Parent, $a_Control
	; Si dimension 1, c'est une liste
	If $dimension = 1 Then
		Local $taille = UBound($elem, 1)
		For $i = 0 To $taille - 1
			$a_Control = $elem[$i]
			$i_Parent = SkinGet($a_Control, "parent")
			If $i_Parent <> Default Then SkinSet($a_Control, "parentid", SkinGet($elem[$i_Parent], "id"))
			skinnerElement($a_Control)
			$elem[$i] = $a_Control
		Next
	ElseIf $dimension > 1 Then ; Si dimension 2, c'est un controle
		skinnerElement($elem)
	EndIf
EndFunc   ;==>skinner

Func skinnerElement(ByRef $elem)
	; Dfinition des variables
	Local $id = Default, $nCible, $sType, $sCreate, $sOpt, $sTitle, $sText, $sState, $sFont, $sData, $sDefaultData
	; Algorithme de cration
	$sType = SkinGet($elem, "type")
	Switch $sType
		Case "delete"
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case "gui"
					$id = GUIDelete(SkinGet($elem, "parentid"))
				Case "ctrl"
					$id = GUICtrlDelete(SkinGet($elem, "parentid"))
				Case "tray"
					$id = TrayItemDelete(SkinGet($elem, "parentid"))
				Case "win"
					$sTitle = SkinGet($elem, "parentid")
					If $sTitle = Default Then $sTitle = SkinGet($elem, "title")
					$id = WinClose($sTitle, SkinGet($elem, "text"))
				Case "kill"
					$sTitle = SkinGet($elem, "parentid")
					If $sTitle = Default Then $sTitle = SkinGet($elem, "title")
					$id = WinKill($sTitle, SkinGet($elem, "text"))
				Case Else
					$id = MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch
		Case "gui"
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case Default
					$sTitle = SkinGet($elem, "title")
					If $sTitle = Default Then $sTitle = @ScriptName
					$id = GUICreate($sTitle, SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"), SkinGet($elem, "parentid"))
				Case Else
					MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch
			If $id <> Default Then $nCible = $id
			$sOpt = SkinGet($elem, "setdefbkcolor") ;DefBkColor (!for controls in this GUI!)
			If $sOpt <> Default Then GUICtrlSetDefBkColor(SkinGet($elem, "defbkcolor"), $nCible)
			$sOpt = SkinGet($elem, "setdefcolor") ;DefColo (!for controls in this GUI !)
			If $sOpt <> Default Then GUICtrlSetDefColor(SkinGet($elem, "defcolor"), $nCible)
			$sOpt = SkinGet($elem, "setaccelerators") ;Accelerators
			If $sOpt <> Default Then GUISetAccelerators(SkinGet($elem, "accelerators"), $nCible)
			$sOpt = SkinGet($elem, "setbkcolor") ;BkColor
			If $sOpt <> Default Then GUISetBkColor(SkinGet($elem, "bkcolor"), $nCible)
			$sOpt = SkinGet($elem, "setcoord") ;Coord
			If $sOpt <> Default Then GUISetCoord(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), $nCible)
			$sOpt = SkinGet($elem, "setcursor") ;Cursor
			If $sOpt <> Default Then GUISetCursor(SkinGet($elem, "cursor"), SkinGet($elem, "cursoroverride"), $nCible)
			$sOpt = SkinGet($elem, "setfont") ;Font
			If $sOpt <> Default Then
				$sFont = SkinGet($elem, "fontname")
				If $sFont = Default Then $sFont = "Arial"
				GUISetFont(SkinGet($elem, "fontsize"), SkinGet($elem, "fontweight"), SkinGet($elem, "fontattribute"), $sFont, $nCible, SkinGet($elem, "fontquality"))
			EndIf
			$sOpt = SkinGet($elem, "sethelp") ;Help
			If $sOpt <> Default Then GUISetHelp(SkinGet($elem, "helpfile"), $nCible)
			$sOpt = SkinGet($elem, "seticon") ;Icon
			If $sOpt <> Default Then GUISetIcon(SkinGet($elem, "imageicon"), SkinGet($elem, "imageid"), $nCible)
			$sOpt = SkinGet($elem, "setonevent") ;OnEvent
			If $sOpt <> Default Then GUISetOnEvent(SkinGet($elem, "oneventid"), SkinGet($elem, "onevent"), $nCible)
			$sOpt = SkinGet($elem, "setstate") ;State
			If $sOpt <> Default Then
				$sState = SkinGet($elem, "state")
				If $sState = Default Then $sState = @SW_SHOW
				GUISetState($sState, $nCible)
			EndIf
			$sOpt = SkinGet($elem, "setstyle") ;Style
			If $sOpt <> Default Then GUISetStyle(SkinGet($elem, "style"), SkinGet($elem, "exstyle"), $nCible)
		Case "tray"
			;voil pour le Tray
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case Default
					$sOpt = SkinGet($elem, "settip")
					If $sOpt <> Default Then TraySetToolTip(SkinGet($elem, "text"))
					$sOpt = SkinGet($elem, "setclick")
					If $sOpt <> Default Then TraySetClick(SkinGet($elem, "flag"))
					$sOpt = SkinGet($elem, "seticon")
					If $sOpt <> Default Then TraySetIcon(SkinGet($elem, "imagefile"), SkinGet($elem, "imageid"))
					$sOpt = SkinGet($elem, "setonevent")
					If $sOpt <> Default Then TraySetOnEvent(SkinGet($elem, "eventonevent"), SkinGet($elem, "onevent"))
					$sOpt = SkinGet($elem, "setpauseicon")
					If $sOpt <> Default Then TraySetPauseIcon(SkinGet($elem, "imagefile"), SkinGet($elem, "imageid"))
					$sOpt = SkinGet($elem, "setstate")
					If $sOpt <> Default Then TraySetState(SkinGet($elem, "state"))
				Case "item", "menuitem"
					$id = TrayCreateItem(SkinGet($elem, "text"), SkinGet($elem, "parentid"), SkinGet($elem, "menuentry"), SkinGet($elem, "radio"))
				Case "menu"
					$id = TrayCreateMenu(SkinGet($elem, "text"), SkinGet($elem, "parentid"), SkinGet($elem, "menuentry"))
				Case Else
					MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch
			;options
			If $id <> Default Then
				$nCible = $id
			Else
				$nCible = SkinGet($elem, "parentid")
			EndIf
			;!trayITEM!
			$sOpt = SkinGet($elem, "setonevent") ;OnEvent
			If $sOpt <> Default Then TrayItemSetOnEvent($nCible, SkinGet($elem, "onevent"))
			$sOpt = SkinGet($elem, "setstate") ;State
			If $sOpt <> Default Then TrayItemSetState($nCible, SkinGet($elem, "state"))
			$sOpt = SkinGet($elem, "setdata") ;Text
			If $sOpt <> Default Then TrayItemSetText($nCible, SkinGet($elem, "text"))
		Case "box"
			;MsgBox + Inputbox
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case "msg"
					$sText = SkinGet($elem, "text")
					If $sText = Default Then $sText = " "
					$id = MsgBox(SkinGet($elem, "flag"), SkinGet($elem, "title"), $sText, SkinGet($elem, "timeout"), SkinGet($elem, "parentid"))
				Case "input"
					$sText = SkinGet($elem, "text")
					If $sText = Default Then $sText = " "
					$id = InputBox(SkinGet($elem, "title"), $sText, SkinGet($elem, "default"), SkinGet($elem, "passwordchar"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "timeout"), SkinGet($elem, "parentid"))
				Case "tray", "tip"
					$sOpt = SkinGet($elem, "option")
					If $sOpt = Default Then $sOpt = 0
					TrayTip(SkinGet($elem, "title"), SkinGet($elem, "text"), SkinGet($elem, "timeout"), $sOpt)
				Case Else
					MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch
		Case "ctrl"
			;etc pour les contrles
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case "", Default
					;Rien  crer
				Case "avi"
					$id = GUICtrlCreateAvi(SkinGet($elem, "filename"), SkinGet($elem, "subfileid"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "button", "bouton"
					$id = GUICtrlCreateButton(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "checkbox"
					$id = GUICtrlCreateCheckbox(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "combo"
					$id = GUICtrlCreateCombo(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "contextmenu"
					$id = GUICtrlCreateContextMenu(SkinGet($elem, "control"))
				Case "date"
					$id = GUICtrlCreateDate(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "dummy"
					$id = GUICtrlCreateDummy()
				Case "edit"
					$id = GUICtrlCreateEdit(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "graphic"
					$id = GUICtrlCreateGraphic(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"))
				Case "group"
					$id = GUICtrlCreateGroup(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "icon"
					$id = GUICtrlCreateIcon(SkinGet($elem, "file"), SkinGet($elem, "icon"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "input"
					$id = GUICtrlCreateInput(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "label"
					$id = GUICtrlCreateLabel(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "list"
					$id = GUICtrlCreateList(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "listview"
					$id = GUICtrlCreateListView(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "listviewitem"
					$id = GUICtrlCreateListViewItem(SkinGet($elem, "text"), SkinGet($elem, "listview"))
				Case "menu"
					$id = GUICtrlCreateMenu(SkinGet($elem, "text"), SkinGet($elem, "parentid"), SkinGet($elem, "order"))
				Case "menuitem", "item"
					$id = GUICtrlCreateMenuItem(SkinGet($elem, "text"), SkinGet($elem, "parentid"), SkinGet($elem, "order"), SkinGet($elem, "radio"))
				Case "monthcal"
					$id = GUICtrlCreateMonthCal(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "obj"
					$id = GUICtrlCreateObj(SkinGet($elem, "object"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"))
				Case "pic"
					$id = GUICtrlCreatePic(SkinGet($elem, "file"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "progress"
					$id = GUICtrlCreateProgress(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "radio"
					$id = GUICtrlCreateRadio(SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "slider"
					$id = GUICtrlCreateSlider(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "tab"
					$id = GUICtrlCreateTab(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "tabitem"
					$id = GUICtrlCreateTabItem(SkinGet($elem, "text"))
				Case "treeview"
					$id = GUICtrlCreateTreeView(SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
				Case "treeviewitem"
					$id = GUICtrlCreateTreeViewItem(SkinGet($elem, "text"), SkinGet($elem, "treeviewID"))
				Case "updown"
					$id = GUICtrlCreateUpdown(SkinGet($elem, "control"), SkinGet($elem, "style"))
				Case Else
					; A continuer
					MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch ;Objet  crer
			If $id <> Default Then
				$nCible = $id
			Else
				$nCible = SkinGet($elem, "parentid")
			EndIf
			$sOpt = SkinGet($elem, "setstate") ;State
			If $sOpt <> Default Then GUICtrlSetState($nCible, SkinGet($elem, "state"))
			$sOpt = SkinGet($elem, "setsort") ;ListViewSort
			If $sOpt <> Default Then GUICtrlRegisterListViewSort($nCible, SkinGet($elem, "listviewsort"))
			$sOpt = SkinGet($elem, "setbkcolor") ;BkColor
			If $sOpt <> Default Then GUICtrlSetBkColor($nCible, SkinGet($elem, "bkcolor"))
			$sOpt = SkinGet($elem, "setcolor") ;Color
			If $sOpt <> Default Then GUICtrlSetColor($nCible, SkinGet($elem, "color"))
			$sOpt = SkinGet($elem, "setcursor") ;Cursor
			If $sOpt <> Default Then GUICtrlSetCursor($nCible, SkinGet($elem, "cursor"))
			$sOpt = SkinGet($elem, "setdata") ;Data
			If $sOpt <> Default Then
				$sData = SkinGet($elem, "data")
				If $sData = Default Then
					$sData = GUICtrlRead($nCible, 1)
					If $sData = 0 Then $sData = GUICtrlRead($nCible, 0)
				EndIf
				$sDefaultData = SkinGet($elem, "defaultdata")
				If $sDefaultData = Default Then $sDefaultData = ""
				GUICtrlSetData($nCible, $sData, $sDefaultData)
			EndIf
			$sOpt = SkinGet($elem, "setfont") ;Font
			If $sOpt <> Default Then
				$sFont = SkinGet($elem, "fontname")
				If $sFont = Default Then $sFont = "Arial"
				GUICtrlSetFont($nCible, SkinGet($elem, "fontsize"), SkinGet($elem, "fontweight"), SkinGet($elem, "fontattribute"), $sFont, SkinGet($elem, "fontquality"))
			EndIf
			$sOpt = SkinGet($elem, "setgraphic") ;Graphic
			If $sOpt <> Default Then GUICtrlSetGraphic($nCible, SkinGet($elem, "graphictype"), SkinGet($elem, "graphicpar1"), SkinGet($elem, "graphicpar2"), SkinGet($elem, "graphicpar3"), SkinGet($elem, "graphicpar4"), SkinGet($elem, "graphicpar5"), SkinGet($elem, "graphicpar6"))
			$sOpt = SkinGet($elem, "setimage") ;Image
			If $sOpt <> Default Then GUICtrlSetImage($nCible, SkinGet($elem, "imagefile"), SkinGet($elem, "imageicon"), SkinGet($elem, "imagetype"))
			$sOpt = SkinGet($elem, "setlimit") ;Limit
			If $sOpt <> Default Then GUICtrlSetLimit($nCible, SkinGet($elem, "limitmax"), SkinGet($elem, "limitmin"))
			$sOpt = SkinGet($elem, "setonevent") ;OnEvent
			If $sOpt <> Default Then GUICtrlSetOnEvent($nCible, SkinGet($elem, "onevent"))
			$sOpt = SkinGet($elem, "setpos") ;Pos
			If $sOpt <> Default Then GUICtrlSetPos($nCible, SkinGet($elem, "posleft"), SkinGet($elem, "postop"), SkinGet($elem, "poswidth"), SkinGet($elem, "posheight"))
			$sOpt = SkinGet($elem, "setresizing") ;Resizing
			If $sOpt <> Default Then GUICtrlSetResizing($nCible, SkinGet($elem, "resizing"))
			$sOpt = SkinGet($elem, "setstyle") ;Style
			If $sOpt <> Default Then GUICtrlSetStyle($nCible, SkinGet($elem, "style"), SkinGet($elem, "exstyle"))
			$sOpt = SkinGet($elem, "settip") ;Tip
			If $sOpt <> Default Then GUICtrlSetTip($nCible, SkinGet($elem, "tiptext"), SkinGet($elem, "tiptitle"), SkinGet($elem, "tipicon"), SkinGet($elem, "tipoption"))
		Case "win"
			$sTitle = SkinGet($elem, "parentid")
			If $sTitle = Default Then $sTitle = SkinGet($elem, "title")
			$sCreate = SkinGet($elem, "create")
			Switch $sCreate
				Case "activate"
					WinActivate($sTitle, SkinGet($elem, "text"))
				Case "flash"
					WinFlash($sTitle, SkinGet($elem, "text"), SkinGet($elem, "flash"), SkinGet($elem, "timeout"))
				Case "wait"
					WinWait($sTitle, SkinGet($elem, "text"), SkinGet($elem, "timeout"))
				Case "waitactive"
					WinWaitActive($sTitle, SkinGet($elem, "text"), SkinGet($elem, "timeout"))
				Case "waitclose"
					WinWaitClose($sTitle, SkinGet($elem, "text"), SkinGet($elem, "timeout"))
				Case "waitnotactive"
					WinWaitNotActive($sTitle, SkinGet($elem, "text"), SkinGet($elem, "timeout"))
				Case Default
					$sOpt = SkinGet($elem, "setpos")
					If $sOpt <> Default Then WinMove($sTitle, SkinGet($elem, "text"), SkinGet($elem, "left"), SkinGet($elem, "top"), SkinGet($elem, "width"), SkinGet($elem, "height"), SkinGet($elem, "speed"))
					$sOpt = SkinGet($elem, "setontop")
					If $sOpt <> Default Then WinSetOnTop($sTitle, SkinGet($elem, "text"), SkinGet($elem, "flag"))
					$sOpt = SkinGet($elem, "setstate")
					If $sOpt <> Default Then WinSetState($sTitle, SkinGet($elem, "text"), SkinGet($elem, "state"))
					$sOpt = SkinGet($elem, "setdata")
					If $sOpt <> Default Then WinSetTitle($sTitle, SkinGet($elem, "text"), SkinGet($elem, "data"))
					$sOpt = SkinGet($elem, "settrans")
					If $sOpt <> Default Then WinSetTrans($sTitle, SkinGet($elem, "text"), SkinGet($elem, "trans"))
				Case Else
					MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "' avec un lment de type '" & $sCreate & "'.")
			EndSwitch
		Case Else
			MsgBox(0, "Erreur : woot", "Vous ne pouvez pas faire de '" & $sType & "'.")
	EndSwitch
	SkinSet($elem, "id", $nCible)
EndFunc   ;==>skinnerElement
#EndRegion Skinner