Func FileGetProperties($file)
	Local $properties[9][2] = [[8, ""] _
		, ["Nom (short)",          ""] _
		, ["Nom (long)",           ""] _
		, ["Version (short)",      ""] _
		, ["Version (long)",       ""] _
		, ["Description (short)",  ""] _
		, ["Description (long)",   ""] _
		, ["Type",                 ""] _
		, ["Auteur",               ""] _
		, ["Site",                 ""] _
	]
	For $i = 1 To $properties[0][0]
		$properties[$i][1] = FileGetProperty($file, $properties[$i][0])
	Next
	Return $properties
EndFunc

Func FileGetProperty($file, $property)
	Local $value = ""
	If StringRegExp(StringLower($file), "\.au3$") Then
		$start = "#AutoIt3Wrapper_Res_Field="&$property&"|"
		Local $flux = FileOpen($file, 0)
		If Not @error And $file <> -1 Then
			For $i = 1 To 25
				Local $line = FileReadLine($flux, $i)
				If @error Then ExitLoop
				If StringLeft($line,StringLen($start)) = $start Then
					$value = StringTrimLeft($line,StringLen($start))
					ExitLoop
				EndIf
			Next
		EndIf
		FileClose($file)
	Else
		$value = FileGetVersion($file, $property)
		If @error Then $value = ""
	EndIf
	Return $value
EndFunc