; Appel du script avec argument : "Lancement Compilation.au3" ligne [delai]
; [in]  ligne [obligatoire] = ligne de commande transforme en hexadcimal
; [in]  delai [optionnel]   = delai
; [out] exit code = 0  : Arret normal
; [out] exit code = -1 : Interrompu par utilisateur
; [out] exit code = 1  : Argument invalide
; [out] exit code = 2  : Argument non conforme
; [out] exit code = 3  : Timeout atteint

#NoTrayIcon

; Programme en stand alone, ne pas faire de include de "Lancement Compilation.au3"

#Include <String.au3>

; Fonction d'arret par HotKey
Func force()
	$force = True
EndFunc
; Fonction conditionnelle rapide
Func cond($a,$b,$c)
	If $a Then Return $b
	Return $c
EndFunc

; Argument en parametre d'excution
If $cmdLine[0] <> 2 And $cmdLine[0] <> 3 Then Exit 1

; Initialisation du timer et du delai
Global $timer = TimerInit(),    $force = False
Global $timerOriginal = $timer, $continue = True
Global $sleep = 500, $delai = 120000 ; 120.000 ms = 2 minutes
Global $type = Number($cmdLine[1])
If $cmdLine[0] = 3 Then $delai = Number($cmdLine[3])

; Lancement du processus de compilation
Global $ligne = _HexToString($cmdLine[2])
If @error Then Exit 2
$PID = Run($ligne)

; Systme d'arret forc
HotKeySet("{F4}", "force")
; Vrification de la prsence du processus Aut2exe (compilateur) et de la validit du timer (delai non atteint)
While $continue
	Do
		Sleep($sleep)
	Until $force Or TimerDiff($timer) > $delai Or Not ProcessExists($PID)
	If Not $force And TimerDiff($timer) > $delai And ProcessExists($PID) Then
		$continue = (6 = MsgBox(4+48,cond($type=0,"Pr-c","C")&"ompilation en cours","La commande de compilation suivante est en cours depuis plus de "&Int(TimerDiff($timerOriginal)/60000)&" minutes :"&@CRLF&$ligne&@CRLF&@CRLF&"Souhaitez vous continuer  attendre ?",30))
		If $continue Then $timer = TimerInit()
	Else
		$continue = False
	EndIf
WEnd

; Cas de retour du code d'erreur
If TimerDiff($timer) > $delai Then
	ProcessClose($PID)
	Exit 3
ElseIf $force = True Then
	ProcessClose($PID)
	Exit -1
Else
	Exit 0
EndIf
